<?php
/** 
* @file AdminBlocks.php
* AdminBlocks reached all Posts from Blocks Manager. 
* Checks the values and saved the parameter to the database.
*
* @author PortaMx - Portal Management Extension
* @author Copyright 2008-2009 by PortaMx - http://portamx.com
* @Version: 0.957
* @Date: 11.03.2009
*/

if(!defined('PortaMx'))
	die('This file can\'t be run without PortaMx');

/**
* Receive all the Posts from Blockmanager, check and save it. 
* Finally the Admin settings are prepared and the templare loaded.
*/
function PortaMx_AdminBlocks()
{
	global $smcFunc, $context, $settings, $sourcedir, $txt;

	$admMode = isset($_REQUEST['action']) ? $_REQUEST['action'] : '';
	if(($admMode == 'admin' || $admMode == 'moderate') && isset($_REQUEST['area']) && $_REQUEST['area'] == 'pmx_blocks')
	{
		$context['PortaMx']['editaction']	= '';
		if(allowedTo('manage_portamx') || allowedTo('admin_forum'))
		{
			require_once($context['PMx_sourcedir'] .'AdminSubs.php');
			$context['PortaMx']['subaction'] = isset($_REQUEST['sa']) ? $_GET['sa'] : 'all';
			$pmx_area = $_REQUEST['area'];

			// From template ?
			if(!empty($_POST))
			{
				checkSession('post');

				// overview - delete block?
				if(isset($_POST['block_delete']))
				{
					$Id = PortaMx_makeSafe($_POST['block_delete']);
					if(!empty($context['PortaMx']['settings']['manager']['follow']) && $context['PortaMx']['subaction'] == 'all')
					{
						$request = $smcFunc['db_query']('', '
								SELECT side 
								FROM {db_prefix}portamx_blocks
								WHERE id = {int:id}',
							array('id' => $Id)
						);
						$side = $smcFunc['db_fetch_assoc']($request);
						$smcFunc['db_free_result']($request);
						$context['PortaMx']['subaction'] = $side['side'];
					}

					$smcFunc['db_query']('', '
							DELETE FROM {db_prefix}portamx_blocks
							WHERE id = {int:id}',
						array('id' => $Id)
					);
					redirectexit('action='. $admMode .';area='. $pmx_area .';sa='. $context['PortaMx']['subaction'] .';'. $context['session_var'] .'='. $context['session_id']);
				}

				// overview - status changed?
				if(isset($_POST['chg_status']))
				{
					$Id = PortaMx_makeSafe($_POST['chg_status']);
					$smcFunc['db_query']('', '
							UPDATE {db_prefix}portamx_blocks
							SET active = NOT(active)
							WHERE id = {int:id}',
						array('id' => $Id)
					);

					if(!empty($context['PortaMx']['settings']['manager']['follow']) && $context['PortaMx']['subaction'] == 'all')
					{
						$request = $smcFunc['db_query']('', '
								SELECT side, active 
								FROM {db_prefix}portamx_blocks
								WHERE id = {int:id}',
							array('id' => $Id)
						);
						$side = $smcFunc['db_fetch_assoc']($request);
						$smcFunc['db_free_result']($request);
						$context['PortaMx']['subaction'] = $side['side'];
					}
					redirectexit('action='. $admMode .';area='. $pmx_area .';sa='. $context['PortaMx']['subaction'] .';'. $context['session_var'] .'='. $context['session_id']);
				}

				// overview - sidechange?
				if(isset($_POST['move_block']))
				{
					$data = preg_split('~\,~', PortaMx_makeSafe($_POST['move_block']), -1, PREG_SPLIT_NO_EMPTY);
					$Id = $data[0];
					$newside = $data[1];
					$pos[0] = 0;
					$request = $smcFunc['db_query']('', '
							SELECT MAX(pos) 
							FROM {db_prefix}portamx_blocks
							WHERE side = {string:side}',
						array('side' => $newside)
					);
					if($smcFunc['db_num_rows']($request) > 0)
					{
						$pos = $smcFunc['db_fetch_row']($request);
						$smcFunc['db_free_result']($request);
					}
					$pos[0]++;

					$smcFunc['db_query']('', '
							UPDATE {db_prefix}portamx_blocks
								SET side = {string:side}, pos = {int:pos}
								WHERE id = {int:id}',
						array(
							'id' => $Id,
							'side' => $newside,
							'pos' => $pos[0]
						)
					);
					if(!empty($context['PortaMx']['settings']['manager']['follow']))
						$context['PortaMx']['subaction'] = $newside;

					redirectexit('action='. $admMode .';area='. $pmx_area .';sa='. $context['PortaMx']['subaction'] .';'. $context['session_var'] .'='. $context['session_id']);
				}

				// overview - Move up / down ?
				if(isset($_POST['move_up']) || isset($_POST['move_down']))
				{
					// get all saved pos
					$request = $smcFunc['db_query']('', '
							SELECT id, pos 
							FROM {db_prefix}portamx_blocks
							WHERE side IN ({array_string:sides})
							ORDER BY pos, side',
						array(
							'sides' => $context['PortaMx']['subaction'] == 'all' ? array('front', 'top', 'left', 'right', 'bottom') : array($context['PortaMx']['subaction']),
						)
					);
					while($row = $smcFunc['db_fetch_assoc']($request))
						$_POST['pos'][$row['id']] = $row['pos'];
					$smcFunc['db_free_result']($request);

					// Move down
					if(isset($_POST['move_down']))
					{
            $FromId = PortaMx_makeSafe($_POST['move_down']);
						unset($_POST['move_down']);

						while(list($key, $val) = each($_POST['pos']))
						{
							if($key == $FromId)
							{
								$FromPos = $val;
								list($ToId, $ToPos) = each($_POST['pos']);
								break;
							}
						} 
					}
					else
          // Move up
					{
						$FromId = PortaMx_makeSafe($_POST['move_up']);
						unset($_POST['move_up']);

						while(list($key, $val) = each($_POST['pos']))
						{
							if($key == $FromId)
							{
								$FromPos = $val;
								break;
							}
							else
							{
							$ToPos = $val;
							$ToId = $key;
							}
						} 
					}
					$_POST['pos'][$ToId] = $FromPos;
					$_POST['pos'][$FromId] = $ToPos;
					$_POST['save_pos'] = 1;
				}

        // overview - Pos update?
				if(isset($_POST['save_pos']))
				{
					$side = array();
					foreach($_POST['pos'] as $id => $pos)
					{
						if(!empty($pos))
						{
							if(!empty($context['PortaMx']['settings']['manager']['follow']) && $context['PortaMx']['subaction'] == 'all' && empty($side))
							{
								$request = $smcFunc['db_query']('', '
										SELECT side 
										FROM {db_prefix}portamx_blocks
										WHERE id = {int:id} AND NOT pos = {int:pos}',
									array(
										'id' => PortaMx_makeSafe($id), 
										'pos' => PortaMx_makeSafe($pos)
									)
								);
								$row = $smcFunc['db_fetch_assoc']($request);
								if(!empty($row) && !in_array($row['side'], $side))
									$side[] = $row['side'];
								$smcFunc['db_free_result']($request);
							}

							$smcFunc['db_query']('', '
									UPDATE {db_prefix}portamx_blocks
									SET pos = {int:pos}
									WHERE id = {int:id}',
								array(
									'id' => PortaMx_makeSafe($id), 
									'pos' => PortaMx_makeSafe($pos)
								)
							);
						}
					}
					if(!empty($context['PortaMx']['settings']['manager']['follow']) && $context['PortaMx']['subaction'] == 'all' && !empty($side))
						$context['PortaMx']['subaction'] = $side[0];

					redirectexit('action='. $admMode .';area='. $pmx_area .';sa='. $context['PortaMx']['subaction'] .';'. $context['session_var'] .'='. $context['session_id']);
				}

				// edit block ?
				if(isset($_POST['edit_block']))
				{
					$Id = PortaMx_makeSafe($_POST['edit_block']);
					$_POST['edit_continue'] = $Id;
					unset($_POST['edit_block']);

					if(!empty($context['PortaMx']['settings']['manager']['follow']) && $context['PortaMx']['subaction'] == 'all')
					{
						$request = $smcFunc['db_query']('', '
								SELECT side
								FROM {db_prefix}portamx_blocks
								WHERE id = {int:id}',
							array('id' => $Id)
						);
						$side = $smcFunc['db_fetch_assoc']($request);
						$smcFunc['db_free_result']($request);
						$context['PortaMx']['subaction'] = $side['side'];
					}
				}

				// edit block - blocktype change?
				if(isset($_POST['edblock_blocktypechg']))
				{
					$id = PortaMx_makeSafe($_POST['edblock_blocktypechg']);
					$_POST['edit_continue'] = $id;
					$_POST['save_edit'] = $id;
					unset($_POST['edblock_blocktypechg']);
					$_POST['cache'] = 0;
				}

				// edit block - cssfile change?
				if(isset($_POST['edblock_ccsfilechg']))
				{
					$id = PortaMx_makeSafe($_POST['edblock_ccsfilechg']);
					$_POST['edit_continue'] = $id;
					$_POST['save_edit'] = $id;
					unset($_POST['edblock_ccsfilechg']);
				}

				// save from edit block?
				if(isset($_POST['save_edit']) && is_numeric(PortaMx_makeSafe($_POST['save_edit'])))
				{
					// fix IE bugs...
					if(empty($_POST['cache']))
						$_POST['cache'] = 0;
					if(empty($_POST['content']))
						$_POST['content'] = '';

					// check defined numeric vars (check_num_vars holds the posted array to check like [varname][varname] ...)
					if(isset($_POST['check_num_vars']))
					{
						foreach($_POST['check_num_vars'] as $val)
						{
							$data = explode(',', $val);
							$post = '$_POST'. str_replace(array('[', ']'), array('[\'', '\']'), $data[0]);
							if(eval("return isset($post);") && eval("return !is_numeric($post);"))
									eval("$post = $data[1];");
						}
						unset($_POST['check_num_vars']);
					}

					// convert content from html to bbc?
					if(!empty($_POST['html_to_bbc']))
					{
						unset($_POST['html_to_bbc']);

						require_once($sourcedir . '/Subs-Editor.php');
						if(isset($_POST['config_html']))
						{
							$_POST['config']['html'] = html_to_bbc(PortaMx_makeSafeContent($_POST['config_html']));
							unset($_POST['config_html']);
						}
						else
							$_POST['content'] = html_to_bbc(PortaMx_makeSafeContent($_POST['content']));
						unset($_POST['html_to_bbc']);
					}
					if(isset($_POST['config_html']))
					{
						$_POST['config']['html'] = PortaMx_makeSafeContent($_POST['config_html']);
						unset($_POST['config_html']);
					}

					$config = serialize($_POST['config']);
					$Id = PortaMx_makeSafe($_POST['save_edit']);
					$isShoutbox = PortaMx_makeSafe($_POST['blocktype']) == 'shoutbox';

					// continue edit ?
					if(isset($_POST['edit_continue']) || $isShoutbox)
					{
						// Get the old content
						$request = $smcFunc['db_query']('', '
								SELECT content 
									FROM {db_prefix}portamx_blocks
									WHERE id = {int:id}',
							array(
								'id' => $Id,
							)
						);
						$row = $smcFunc['db_fetch_assoc']($request);
						$smcFunc['db_free_result']($request);

						if($isShoutbox)
							$_POST['content'] = $row['content'];
					}

					// check cache time value
					$cache = PortaMx_makeSafe($_POST['cache']);
					if(!is_numeric($cache))
						$cache = eval("return $cache;");	// if insert as xx * xx
					if(!is_numeric($cache))
						$cache = 0;

					$request = $smcFunc['db_query']('', '
							SELECT side 
							FROM {db_prefix}portamx_blocks
							WHERE id = {int:id}',
						array('id' => $Id)
					);
					$side = $smcFunc['db_fetch_assoc']($request);
					$smcFunc['db_free_result']($request);

					// now save all values
					$smcFunc['db_query']('', '
							UPDATE {db_prefix}portamx_blocks
							SET cache = {int:cache},
									cacherefresh = {int:cacherefresh},
									blocktype = {string:blocktype},
									config = {string:config},
									content = {string:content}
							WHERE id = {int:id}',
						array(
							'cache' => $cache,
							'cacherefresh' => 0,
							'blocktype' => PortaMx_makeSafe($_POST['blocktype']),
							'config' => $config,
							'content' => (isset($_POST['edit_continue']) ? (!empty($row['content']) ? $row['content'] : PortaMx_makeSafeContent($_POST['content'], $_POST['blocktype'])) : PortaMx_makeSafeContent($_POST['content'], $_POST['blocktype'])),
							'id' => $Id,
						)
					);
				}

				// add new block ?
				if(isset($_POST['add_new_block']))
				{
					// get max pos
					$pos[0] = 0;
					$request = $smcFunc['db_query']('', '
							SELECT MAX(pos) 
							FROM {db_prefix}portamx_blocks
							WHERE side = {string:side}',
						array('side' => PortaMx_makeSafe($_POST['add_new_block']))
					);
					if($smcFunc['db_num_rows']($request) > 0)
					{
						$pos = $smcFunc['db_fetch_row']($request);
						$smcFunc['db_free_result']($request);
					}
					$pos[0]++;

					// create a empty block
					$smcFunc['db_insert']('', '
						{db_prefix}portamx_blocks',
						array(
							'side' => 'string',
							'pos' => 'int',
							'active' => 'int',
							'cache' => 'int',
							'cacherefresh' => 'int',
							'blocktype' => 'string',
							'config' => 'string',
							'content' => 'string'
						),
						array(
							PortaMx_makeSafe($_POST['add_new_block']),
							$pos[0],
							0,
							0,
							-1,
							'default',
							serialize(PortaMx_getDefaultConfig()),
							'',
						),
						array('id')
					);
					$_POST['edit_continue'] = $smcFunc['db_insert_id']('{db_prefix}portamx_blocks', 'id');
				}

				// continue edit ?
				if(isset($_POST['edit_continue']))
					redirectexit('action='. $admMode .';area='. $pmx_area .';sa='. $context['PortaMx']['subaction'] .';blockedit='. $_POST['edit_continue'] .';'. $context['session_var'] .'='. $context['session_id']);
				else
					redirectexit('action='. $admMode .';area='. $pmx_area .';sa='. $context['PortaMx']['subaction'] .';'. $context['session_var'] .'='. $context['session_id']);
			}
			else
			{
				checkSession('get');

				if(isset($_GET['blockedit']))
				{
					if(is_numeric(PortaMx_makeSafe($_GET['blockedit'])))
					{
						$context['PortaMx']['adm_editblock'] = PortaMx_getAdmEditBlock(PortaMx_makeSafe($_GET['blockedit']));
						$context['PortaMx']['editaction'] = 'adm_editblock';
					}
					else
						fatal_error($txt['pmx_actionfault']);
				}
				else
					// Load data for overview
					$context['PortaMx']['admblocks'] = PortaMx_getAdmBlocks();
			}

			// setup pagetitle and load the javascript
			$context['page_title'] = $txt['pmx_blocks'];
			// $context['html_headers'] .= '
			// <script language="JavaScript" type="text/javascript" src="'. $context['PMx_scripturl'] .'AdminBlocks.js"></script>';

			// Load the Admin/Moderation tabs
			$context['PortaMx']['AdminMode'] = $admMode;
			$context[$context[$admMode == 'admin' ? 'admin_menu_name' : 'moderation_menu_name']]['tab_data'] = array(
				'title' => $admMode == 'admin' ? $txt['pmx_blocks'] : $txt['pmx_blocks_mod'],
				'description' => $txt['pmx_admBlk_desc'] .(allowedTo('manage_portamx') && !allowedTo('admin_forum') ? $txt['pmx_admBlk_desc_mod'] : ''),
				'tabs' => array(
					'all' => array(),
					'top' => array(),
					'left' => array(),
					'right' => array(),
					'bottom' => array(),
					'front' => array(),
					'pages' => array(),
				),
			);

			// load language and execute template
			loadLanguage($context['PMx_templatedir'] .'AdminBlocks');
			loadTemplate($context['PMx_templatedir'] .'AdminBlocks');
		}
		else
			isAllowedTo('admin_forum');
	}
}
?>