<?php
/** 
* @file Admin.php
* Admininistration Center. 
*
* @author PortaMx - Portal Management Extension
* @author Copyright 2008-2009 by PortaMx - http://portamx.com
* @Version: 0.957
* @Date: 11.03.2009
*/

if(!defined('PortaMx'))
	die('This file can\'t be run without PortaMx');

/**
* Create all the Informationen for the Admin Center. 
* Finally load the templare.
*/
function PortaMx_AdminCenter()
{
	global $smcFunc, $context, $settings, $scripturl, $sourcedir, $boarddir, $txt;

	isAllowedTo('admin_forum');

	$context['PortaMx']['subaction'] = isset($_REQUEST['sa']) ? $_REQUEST['sa'] : 'main';
	if($context['PortaMx']['subaction'] == 'settings')
		$context['PortaMx']['subaction'] = 'main';
	$context['PortaMx']['pmx_area'] = $_REQUEST['area'];

	// Admin center main?
	if($context['PortaMx']['subaction'] == 'main')
	{
		// show the Admin center
		$liveinfo = getLiveInfo();
		$context['pmx_info'] = $liveinfo;
		$context['pmx_info']['installed'] = getInstalledPackage();
		$context['pmx_info']['versionOK'] = !empty($liveinfo['version']) && $liveinfo['version'] == $context['pmx_info']['installed'];

		// If update available, get server from package_server table
		if(!empty($context['pmx_info']['update']) && empty($context['pmx_info']['versionOK']))
		{
			$request = $smcFunc['db_query']('', '
					SELECT id_server 
					FROM {db_prefix}package_servers
					WHERE url = {string:url}',
				array(
					'url' => substr($context['PortaMx']['server']['url'], 0, -1)
				)
			);
			if($row = $smcFunc['db_fetch_assoc']($request))
			{
				$context['pmx_info']['updserver'] = $row['id_server'];
				$smcFunc['db_free_result']($request);
			}
			else
			{
				$smcFunc['db_insert']('', '
					{db_prefix}package_servers',
					array(
						'name' => 'string', 
						'url' => 'string'
					),
					array(
						'PortaMx File Server', 
						substr($context['PortaMx']['server']['url'], 0, -1),
					),
					array('id_server')
				);
				$context['pmx_info']['updserver'] = $smcFunc['db_insert_id']('{db_prefix}package_servers', 'id_server');
			}
		}
	}

	// detailed filelist ?
	elseif($context['PortaMx']['subaction'] == 'flist')
	{
		checkSession('get');

		$dirs = array(
			'pmx_source_files' => array(
				$sourcedir => array('/PortaMx/', '/PortaMx/Class/', '/PortaMx/Class/System/'),
			),
			'pmx_template_files' => array(
				$settings['default_theme_dir'] => array('/PortaMx/', '/PortaMx/Scripts/', '/PortaMx/SysCss/'),
			),
			'pmx_language_files' => array(
				$settings['default_theme_dir'] .'/languages' => array('/PortaMx/', '/PortaMx/Blocks/'),
			),
		);

		// read all dirs
		foreach($dirs as $dirname => $basedirs)
		{
			foreach($basedirs as $base => $subdirs)
			{
				foreach($subdirs as $dir)
				{
					if(is_dir($base . $dir)) 
					{
						$files = array();
						if($dh = opendir($base . $dir))
						{
							while(($file = readdir($dh)) !== false)
							{
								if(is_file($base . $dir . $file))
									$files[] = $file;
							}
							closedir($dh);
						}
					}

					$allfiles[$dirname][] = array(
						'dir' => $base . $dir,
            'subdir' => $dir,
						'files' => $files,
					);
				}
			}
		}
		// cleanup..
		unset($dirs[$dirname]);

		// get lifeinfo
		$currentversion = getLiveInfo('version');

		// Package ...
		$result['pmx_filepackage']['files'][''] = array();
		$result['pmx_filepackage']['current'] = $currentversion;
		$result['pmx_filepackage']['installed'] = getInstalledPackage();

			// check all files
		foreach($allfiles as $dirtext => $dirname)
		{
			$lowdate = '31.12.3000';
			$lowversion = '99.999';
			foreach($dirname as $data)
			{
				$subdir = $data['subdir'];
				foreach($data['files'] as $file)
				{
					$handle = fopen($data['dir'] . $file, "r");
					$content = fread($handle, 512);
					fclose($handle);

					$versOK = preg_match("~\@Version:\s([0-9\.]+)~i", $content, $version) != 0;
					if($versOK && $version[1] < $lowversion)
						$lowversion = $version[1];
					$dateOK = preg_match("~\@Date:\s([0-9\.]+)~i", $content, $date) != 0;
					if($dateOK && $date[1] < $lowdate)
						$lowdate = $date[1];

					$result[$dirtext]['files'][$file] = array(
						'subdir' => $subdir,
						'version' => ($versOK ? $version[1] : '?.???'),
						'date' => ($dateOK ? $date[1] : '??.??.????'),
					);
					unset($content);
				}
			}
			$result[$dirtext]['current'] = $currentversion;
			$result[$dirtext]['installed'] = $lowversion;
			$result[$dirtext]['lowdate'] = $lowdate;
		}
		$context['pmx_info'] = $result;
		unset($result);
	}

	// show languages?
	elseif($context['PortaMx']['subaction'] == 'showlang')
	{
		checkSession('get');

		// get all installed languages
		$context['PortaMx']['instlang'] = getInstalledLanguages();

		// get all existing languages
		$context['PortaMx']['languages'] = array();
		$info = readDocServer($context['PortaMx']['server']['lang']);
		if(!empty($info))
		{
			if(GetFirstChildContentByName($info, 'copyright') == 'PortaMx')
			{
				$elmlist = GetChildByPathAndName($info, '', 'item');
				foreach($elmlist as $elm)
				{
					$context['PortaMx']['langsets'][] = array(
						'name' => GetFirstChildContentByName($elm, 'name'),
						'version' => GetFirstChildContentByName($elm, 'version'),
						'charset' => GetFirstChildContentByName($elm, 'charset'),
						'link' => GetFirstChildContentByName($elm, 'link'),
					);
				}
			}
			else
				AdmCenterError($txt['pmx_center_langfetchfailed']);
		}
		else
			AdmCenterError($txt['pmx_center_langfetchfailed']);
	}

	// Administrate languages?
	elseif($context['PortaMx']['subaction'] == 'admlang')
	{
		checkSession('post');

		// lang delete ?
		if(isset($_POST['lang_delete']) && !empty($_POST['lang_delete']))
		{
			// get the values...
			$langId = PortaMx_makeSafe($_POST['lang_delete']);
			$removeSet = getInstalledLanguages($langId);
			$themePath = $settings['default_theme_dir'] . '/languages/PortaMx';
			$failed = false;

			foreach($removeSet['files'] as $file => $path)
			{
				$filename = $themePath . $path . $file . $removeSet['langext'] .'.php';  
				if(file_exists($filename))
				{
					if(!is_writable($filename))
					{
						@chmod($filename, 0644);
						if(!is_writable($filename))
							@chmod($filename, 0777);
					}
					if(!unlink($filename))
					{
						$failed =  true;
						break;
					}
				}
			}

			if(empty($failed))
			{
				sleep(1);
				// remove the language from installed
				$smcFunc['db_query']('', '
						DELETE FROM {db_prefix}portamx_settings
						WHERE id = {int:id}',
					array('id' => $langId)
				);

				// reorder Id's
				$request = $smcFunc['db_query']('', '
						SELECT id
						FROM {db_prefix}portamx_settings
						WHERE id >= {int:id}',
					array(
						'id' => $langId,
					)
				);
				while($row = $smcFunc['db_fetch_assoc']($request))
					$result[] = $row['id'];
				$smcFunc['db_free_result']($request);

				if(isset($result) && is_array($result))
				{
					foreach($result as $id)
					{
						$smcFunc['db_query']('', '
								UPDATE {db_prefix}portamx_settings
								SET id = id - 1
								WHERE id = {int:id}',
							array('id' => $id)
						);
					}
				}

				// clear the filecache and redirect exit
				clean_cache();
				redirectexit('action=admin;area='. $context['PortaMx']['pmx_area'] .';sa=showlang;'. $context['session_var'] .'='. $context['session_id']);
			}
			else
				AdmCenterError($txt['pmx_center_langdelfailed'], $txt['pmx_center_langdelerror'], 'showlang');
		}

		// lang install ?
		elseif(isset($_POST['lang_install']) && !empty($_POST['lang_install']))
		{
			// Get the values ...
			$InstLink = PortaMx_makeSafe($_POST['lang_install']);
			$themePath = $settings['default_theme_dir'] . '/languages/PortaMx';
			$failed = false;

			// get the language description
			$langSet = array();
			$langfiles = array();
			$info = readDocServer($context['PortaMx']['server']['lang'] . $InstLink);
			if(GetFirstChildContentByName($info, 'copyright') == 'PortaMx')
			{
				$langSet['name'] = GetFirstChildContentByName($info, 'name');
				$langSet['version'] = GetFirstChildContentByName($info, 'version');
				$langSet['charset'] = GetFirstChildContentByName($info, 'charset');
				$langSet['langext'] = GetFirstChildContentByName($info, 'langext');

				// filelist
				$elmlist = GetChildByPathAndName($info, '', 'item');
				foreach ($elmlist as $elm) 
				{
					$fname = GetFirstChildContentByName($elm, 'name');
					$langfiles[$fname] = GetFirstChildContentByName($elm, 'path');
				}

				// now get languagefiles from Portamx server
				foreach($langfiles as $file => $path)
				{
					$content = readDocServer($context['PortaMx']['server']['lang'] . $InstLink .'PortaMx'. $path . $file . $langSet['langext'], '<?php');
					$content = trim($content);
					if(!empty($content))
					{
						$fsize = strlen($content);
						$filename = $themePath . $path . $file . $langSet['langext'] .'.php';  

						if(file_exists($filename))
						{
							if(!is_writable($filename))
							{
								@chmod($filename, 0644);
								if(!is_writable($filename))
									@chmod($filename, 0777);
							}
						}

						if(empty($failed))
						{
							$written = 0;
							$fhd = fopen($filename, 'w');
							if($fhd)
							{
								$written = fwrite($fhd, $content);
								fclose($fhd);
							}
						}

						if(!empty($failed) || $written != $fsize)
						{
							$failed = true;
							break;
						}
					}
					else
					{
						AdmCenterError($txt['pmx_center_langfetchfailed'], $txt['pmx_center_langinsterror'], 'showlang');
						$failed = true;
						break;
					}
				}
			}
			else
			{
				AdmCenterError($txt['pmx_center_langfetchfailed'], $txt['pmx_center_langinsterror'], 'showlang');
				$failed = true;
			}

			if(empty($failed))
			{
				sleep(1);
				// add or replace the installed language
				$langlist = getInstalledLanguages();
				$instId = 0;
				foreach($langlist as $id => $data)
					$instId = compareLang(array($data['name'], $data['charset']), array($langSet['name'], $langSet['charset'])) ? $id : $instId;

				if(empty($instId))		// add
					$instId = $context['PortaMx']['settings']['dbsetid']['instlang'] + count($langlist);

				$lset = array(
					'name' => $langSet['name'],
					'version' => $langSet['version'],
					'charset' => $langSet['charset'],
					'langext' => $langSet['langext'],
					'files' => $langfiles,
				);

				// save installed languages
				$smcFunc['db_insert']('replace', '
					{db_prefix}portamx_settings',
					array(
						'id' => 'int', 
						'config' => 'string'
					),
					array(
						$instId,
						serialize($lset),
					),
					array('id')
				);
				// clear the filecache and redirect exit
				clean_cache();
				redirectexit('action=admin;area='. $context['PortaMx']['pmx_area'] .';sa=showlang;'. $context['session_var'] .'='. $context['session_id']);
			}
			else
				AdmCenterError($txt['pmx_center_langinstfailed'], $txt['pmx_center_langinsterror'], 'showlang');
		}
		else
			AdmCenterError($txt['pmx_actionfault']);
	}

	// Administrator Manual?
	elseif($context['PortaMx']['subaction'] == 'admbook')
	{
		if(isset($_REQUEST['page']) && !empty($_REQUEST['page']))
			$manpage = PortaMx_makeSafe($_REQUEST['page']);
		else
			$manpage = 'index';

		$context['PortaMx']['manpage'] = array(
			'title' => '',
			'content' => '<span class="title">Can\'t read the manpage "'. $manpage .'" from PortaMx document server</span>'
		);

		$info = readDocServer($context['PortaMx']['server']['manual'] . $manpage, 'man');
		if(!empty($info))
		{
			if(GetFirstChildContentByName($info, 'copyright') == 'PortaMx')
			{
				$_SESSION['pmx_manpage_tree'] = array();
				$elmlist = GetChildByPathAndName($info, 'menu', 'item');
				foreach($elmlist as $elm)
				{
					$page = GetAttribByName($elm, 'page');
					$desc = $elm->content;
					$_SESSION['pmx_manpage_tree'][] = array($page => $desc);
					$context['PortaMx']['manpage']['title'] = $desc;
				}

				$context['PortaMx']['manpage']['content'] = GetFirstChildContentByName($info, 'content');

				// replace php in content
				if(preg_match_all("~<\?php(.*)\?>~is", $context['PortaMx']['manpage']['content'], $matches, PREG_SET_ORDER))
				{
					foreach($matches as $data)
					{
						$data[1] = str_replace("\t", '  ', $data[0]);
						$data[1] = str_replace(array("\n", "\r"), '', $data[1]);
						$data[1] = str_replace('<>', "\n", $data[1]);
						if (@version_compare(PHP_VERSION, '4.2.0') == -1)
						{
							ob_start();
							@highlight_string($data[1]);
							$data[1] = ob_get_contents();
							ob_end_clean();
						}
						else
							$data[1] = @highlight_string($data[1], true);

						$data[1] = str_replace(array('&lt;?php<br />', '?&gt;'), '', $data[1]);
						$context['PortaMx']['manpage']['content'] = str_replace($data[0], '<b style="color:#ffffff;">Code:</b><div class="code">'. $data[1] .'<br /></div>', $context['PortaMx']['manpage']['content']);
					}
				}

				// replace @{link} in content
				if(preg_match_all("~\@\{(.*)\}~iU", $context['PortaMx']['manpage']['content'], $matches, PREG_SET_ORDER))
				{
					foreach($matches as $data)
						$context['PortaMx']['manpage']['content'] = str_replace($data[0], $context['PortaMx']['server']['url'] . $context['PortaMx']['server']['manual'] . $data[1], $context['PortaMx']['manpage']['content']);
				}

				// replace @=manpage{text} in content
				if(preg_match_all("~\@=(.*)\{(.*)\}~iU", $context['PortaMx']['manpage']['content'], $matches, PREG_SET_ORDER))
				{
					foreach($matches as $data)
						$context['PortaMx']['manpage']['content'] = str_replace($data[0], '<a href="'. $scripturl .'?action=admin;area=pmx_center;sa=admbook;page='. $data[1] .'" onclick="return PageLoadStart(this.href);">'. $data[2] .'</a>', $context['PortaMx']['manpage']['content']);
				}

				// replace @?=tooltip{text} in content
				if(preg_match_all("~\@\?=(.*)\{(.*)\}~iU", $context['PortaMx']['manpage']['content'], $matches, PREG_SET_ORDER))
				{
					foreach($matches as $data)
						$context['PortaMx']['manpage']['content'] = str_replace($data[0], '<span style="cursor:help;border-bottom:1px dotted #c0c0c0;" title=" '. $data[2] .' "><i>'. $data[1] .'</i></span>', $context['PortaMx']['manpage']['content']);
				}
			}
		}
	}
	else
		AdmCenterError($txt['pmx_actionfault']);

	// setup pagetitle 
	$context['page_title'] = $txt['pmx_admin_center'];

	// Load the Admin tabs
	$context[$context['admin_menu_name']]['tab_data'] = array(
		'title' => $txt['pmx_admincenter'],
		'help' => '',
		'tabs' => array(
			'pmx_center' => array(),
			'pmx_settings' => array(),
			'pmx_blocks' => array(),
		)
	);

	// load the template
	loadTemplate($context['PMx_templatedir'] .'AdminCenter');

	// Admin books only as Popup
	if($context['PortaMx']['subaction'] == 'admbook')
	{
		$context['template_layers'] = array();
		$context['sub_template'] = 'manual';
	}
}

/**
* Error on Admin Center
*/
function AdmCenterError($errMsg, $title = '', $subaction = '')
{
	global $context, $txt;
  
  if(!empty($context['PortaMx']['isError']))
    return;

  $context['PortaMx']['isError'] = true;
	$context['PortaMx']['subaction'] = 'error';
	$context['PortaMx']['AdmcError'] = array(
		'title' => (empty($title) ? $txt['pmx_center_error'] : $title),
		'msg' => $errMsg,
		'subact' => $subaction,
	);
}

/**
* Compare two languages
*/
function compareLang($SetA, $SetB)
{
	$result = true;
	foreach($SetA as $key => $val)
		$result = (strtolower(trim($val)) != strtolower(trim($SetB[$key])) ? false : $result);

	return $result;
}

/**
* Get the installed languages
*/
function getInstalledLanguages($setID = '')
{
global $smcFunc, $context;

	$result = array();
	$request = $smcFunc['db_query']('', '
			SELECT id, config 
			FROM {db_prefix}portamx_settings
			WHERE id >= {int:id}',
		array(
			'id' => $context['PortaMx']['settings']['dbsetid']['instlang'],
		)
	);
	while($row = $smcFunc['db_fetch_assoc']($request))
		$result[$row['id']] = unserialize($row['config']);
	$smcFunc['db_free_result']($request);

	if(!empty($setID))
		return $result[$setID];
	else
		return $result;
}

/**
* Get the installed package version
*/
function getInstalledPackage()
{
global $smcFunc, $context, $settings, $sourcedir, $txt;

	$result = '?.???';
	$request = $smcFunc['db_query']('', '
			SELECT version
			FROM {db_prefix}log_packages
			WHERE package_id = {string:pktid} AND install_state > 0
			ORDER BY id_install DESC',
		array(
			'pktid' => 'portamx_corp:PortaMx',
		)
	);
	if($row = $smcFunc['db_fetch_assoc']($request))
		$result = $row['version'];
	$smcFunc['db_free_result']($request);

	return $result;
}

/**
* Get info from docserver
*/
function readDocServer($filepath, $header = '<?xml')
{
	global $context;

	if($header == '<?xml')
		$filepath .= 'pmxinfo.xml';
	elseif($header == 'man')
	{
		$header = '<?xml';
		$filepath .= '.xml';
	}
	return ParseXmlurl($context['PortaMx']['server']['url'] . $filepath, 5, $header);
}

/**
* Get the Liveinfo from Database or PortaMx server
* Returns the info array
*/
function getLiveInfo($element = '')
{
	global $smcFunc, $context;

	// read live info from database
	$result = '';
	$request = $smcFunc['db_query']('', '
			SELECT id, config 
			FROM {db_prefix}portamx_settings
			WHERE id = {int:id}',
		array(
			'id' => $context['PortaMx']['settings']['dbsetid']['liveinfo'],
		)
	);

	if($row = $smcFunc['db_fetch_assoc']($request))
		$result = $row['config'];
	$smcFunc['db_free_result']($request);

	// info exist?
	if(!empty($result))
	{
		$liveinfo = unserialize($result);
		// out of TTL .. read from server
		if(time() > $liveinfo['ttl'])
		{
			$result = ReadLiveInfo();
			if(!empty($result))
			{
				unset($liveinfo);
				$liveinfo = $result;
				unset($result);
			}
		}
	}
	else
	// empty .. read from server
		$liveinfo = ReadLiveInfo();

	if(!empty($element))
		return $liveinfo[$element];
	else
		return $liveinfo;
}

/**
* Get the liveinfo from PortaMx
* Returns the info array
*/
function ReadLiveInfo()
{
	global $context, $txt, $smcFunc;

	// get XMLinfo from PortaMx.com
	$liveinfo = readDocServer($context['PortaMx']['server']['live']);

	$info['version'] = '?.???';
	if(!empty($liveinfo))
	{
		if(GetFirstChildContentByName($liveinfo, 'copyright') == 'PortaMx')
		{
			$info['ttl'] = GetFirstChildContentByName($liveinfo, 'ttl');
			if(!empty($info['ttl']))
			{
				$attr = GetFirstChildByName($liveinfo, 'ttl');
				$ttlbase = GetAttribByName($attr, 'timebase');
				if(!empty($ttlbase))
					$info['ttl'] = intval($info['ttl']) * intval($ttlbase);
				$info['ttl'] += time();
			}
			else
				$info['ttl'] = 0;

			$info['version'] = GetFirstChildContentByName($liveinfo, 'version');
			$info['update'] = GetFirstChildContentByName($liveinfo, 'update');
			$info['download'] = GetFirstChildContentByName($liveinfo, 'download');

			$elmlist = GetChildByPathAndName($liveinfo, '', 'item');
			foreach ($elmlist as $elm) 
			{
				$subject = trim(GetFirstChildContentByName($elm, 'subject'));
				$date = trim(GetFirstChildContentByName($elm, 'pubDate'));
				$link = trim(GetFirstChildContentByName($elm, 'link'));
				$msg = trim(GetFirstChildContentByName($elm, 'description'));

				$info['item'][] = array(
					'subject' => (!empty($link) ? '<a href="'. $link .'" target="blank_">'. $subject .'</a>' : $subject),
					'date' => $date,
					'msg' => $msg,
				);
			}

			// save to database ..
			if(!empty($info['ttl']))
				$smcFunc['db_insert']('replace', '
						{db_prefix}portamx_settings',
					array(
						'id' => 'int', 
						'config' => 'string'
					),
					array(
						$context['PortaMx']['settings']['dbsetid']['liveinfo'], 
						serialize($info),
					),
					array('id')
				);
		}
	}
	return $info;
}
?>