<?php
/** 
* @file AdminSubs.php
* AdminSubs holds all subroutines for the Admin part. 
*
* @author PortaMx - Portal Management Extension
* @author Copyright 2008-2009 by PortaMx - http://portamx.com
* @Version: 0.957
* @Date: 11.03.2009
*/

if(!defined('PortaMx'))
	die('This file can\'t be run without PortaMx');

/**
* get all blocks for Block Manager Overview.
*/
function PortaMx_getAdmBlocks()
{
	global $smcFunc, $context;

	$result = array();
	$request = $smcFunc['db_query']('', '
			SELECT * FROM {db_prefix}portamx_blocks
			ORDER BY side ASC, pos ASC',
		array()
	);

	if($smcFunc['db_num_rows']($request) > 0)
	{
		while($row = $smcFunc['db_fetch_assoc']($request))
		{
			unset($row['content']);
			$result[$row['side']][] = new pmxc_AdmBlockOverview($row);
		}
		$smcFunc['db_free_result']($request);
	}
	return $result;
}

/**
* get one blocks for Block Manager Editblock.
*/
function PortaMx_getAdmEditBlock($id)
{
	global $smcFunc, $context, $sourcedir;

	$result = null;
	$request = $smcFunc['db_query']('', '
			SELECT * FROM {db_prefix}portamx_blocks
			WHERE id = {int:id}',
		array('id' => $id)
	);

	if($smcFunc['db_num_rows']($request) > 0)
	{
		$row = $smcFunc['db_fetch_assoc']($request);
		$smcFunc['db_free_result']($request);

		// handle bbc script and download block
		$edit_bbc = !empty($context['PortaMx']['settings']['manager']['edit_bbc']);

		if($row['blocktype'] == 'bbc_script' || ($row['blocktype'] == 'download' && $edit_bbc))
		{
			$content['html'] = $row['content'];
			if($row['blocktype'] == 'download')
				$content = isset($row['config']) ? unserialize($row['config']) : '';
			if(!isset($content['html']))
				$content['html'] = '';

			// create the SMF editor.
			require_once($sourcedir . '/Subs-Editor.php');

			$editorOptions = array(
				'id' => ($row['blocktype'] == ('download' && $edit_bbc) ? 'config_html' : 'content'),
				'value' => str_replace(array('"', '<', '>', '&nbsp;'), array('&quot;', '&lt;', '&gt;', ' '), $content['html']),
				'width' => '100%',
				'height' => ($row['blocktype'] == 'download' ? '150px' : '200px'),
				'labels' => array(),
				'preview_type' => 0,
			);
			create_control_richedit($editorOptions);
			$context['PortaMx']['editorID'] = $editorOptions['id'];
		}
		$block_type = 'pmxc_'. $row['blocktype'] .'_adm';
		$result = new $block_type($row);

		// init the admin block
		$result->pmxc_AdmBlock_loadinit('');
	}
	return $result;
}

/**
* load the xhtml editor.
* field: name of a input element.
* content: the content in the editor or empty.
*/
function PortaMx_EditContent_xhtml($field, $content, $toolbar = 'Default', $height = '400')
{
	global $context, $sourcedir, $boarddir, $boardurl;

	$context['PortaMx']['settings']['xbarkeys'] = 0;		// disable xBarKeys
	require_once($boarddir .'/fckeditor/fckeditor.php');

	$oFCKeditor = new FCKeditor($field);
	$oFCKeditor->BasePath = str_replace('//', '/', str_replace('\\', '/', dirname($_SERVER['SCRIPT_NAME'])) .'/fckeditor/');
	$oFCKeditor->Height = $height .'px';
	$oFCKeditor->ToolbarSet = $toolbar;
	$oFCKeditor->Value = $content;
	$oFCKeditor->Create();
}

/**
* get the setup for default Css classes.
*/
function PortaMx_getdefaultClass()
{
	global $context, $txt;

	$result = array(
		'header' => array(
			' '. $txt['pmx_default_header_none'] => 'none',
			' '. $txt['pmx_default_header_asbody'] => '',
			'+titlebg' => 'titlebg', 
			' titlebg2' => 'titlebg2',
			' catbg' => 'catbg', 
			' catbg2' => 'catbg2',
			' catbg3' => 'catbg3',
		),
		'frame' => array(
			' '.$txt['pmx_default_none'] => '',
			'+tborder' => 'tborder', 
			' bordercolor' => 'bordercolor', 
		), 
		'body' => array(
			' '.$txt['pmx_default_none'] => '',
			'+windowbg' => 'windowbg',
			' windowbg2' => 'windowbg2',
			' windowbg3' => 'windowbg3',
		),
		'bodytext' => array(
			' '.$txt['pmx_default_none'] => '',
			'+smalltext' => 'smalltext',
			' middletext' => 'middletext',
			' normaltext' => 'normaltext',
			' largetext' => 'largetext',
		),
	);
	return $result;
}

/**
* get the default Config.
*/
function PortaMx_getdefaultConfig()
{
	global $context, $txt;

	$config = array(
		'title' => array(),
		'langfile' => '',
		'collapse' => 1,
		'visuals' => array(
			'header' => 'titlebg',
			'frame' => 'tborder',
			'body' => 'windowbg',
			'bodytext' => 'smalltext',
		),
		'cssfile' => '',
		'grp_acs' => array(),
		'mod_acs' => array(),
		'ext_opts' => array(
			'pmxact' => array(),
			'pmxcust' => '',
			'pmxbrd' => array(),
			'pmxlng' => array(),
		),
		'settings' => array(),
	);
	return $config;
}
?>