<?php
/** 
* @file boardnews.php
* Systemblock boardnews
*
* @author PortaMx - Portal Management Extension
* @author Copyright 2008-2009 by PortaMx - http://portamx.com
* @Version: 0.957
* @Date: 11.03.2009
*/

if(!defined('PortaMx'))
	die('This file can\'t be run without PortaMx');

/**
* @class pmxc_boardnews
* Systemblock boardnews
* @see boardnews.php
* @author Copyright by PortaMx - http://portamx.com
*/
class pmxc_boardnews extends PortaMxC_SystemBlock
{
	/**
	* InitContent.
	* Checks the cache status and create the content.
	*/
	function pmxc_InitContent()
	{
		if($this->visible)
		{
			$cstat = $this->pmxc_getCacheStatus();
			if(!empty($cstat) && $cstat < 0)		// refresh need?
			{
				$this->_BoardnewsContent();
				$this->pmxc_updateCache();
			}
			elseif(empty($cstat))
				$this->_BoardnewsContent();
		}
		// return the visibility flag (true/false)
		return $this->visible;
	}

	/**
	* _BoardnewsContent.
	* Prepare the content and save in $this->cfg['content'].
	*/
	function _BoardnewsContent()
	{
		global $context, $scripturl, $smcFunc, $modSettings, $txt;

		$L_R = empty($context['right_to_left']) ? 'left' : 'right';
		$R_L = empty($context['right_to_left']) ? 'right' : 'left';

		if(isset($this->cfg['config']['settings']['board']) && !empty($this->cfg['config']['settings']['board']))
		{
			$posts = ssi_boardNews($this->cfg['config']['settings']['board'], $this->cfg['config']['settings']['total'], null, null, '');
			if(!empty($posts))
			{
				// get attachments if show thumnails set
				if(!empty($this->cfg['config']['settings']['thumbs']))
				{
					$msgids = null;
					foreach($posts as $post)
						$msgids[] = $post['message_id'];

					$request = $smcFunc['db_query']('', '
						SELECT a.id_attach, a.id_thumb, a.filename, a.id_msg, t.id_topic
							FROM {db_prefix}attachments a
							LEFT JOIN {db_prefix}messages m ON (a.id_msg = m.id_msg)
							LEFT JOIN {db_prefix}topics t ON (m.id_topic = t.id_topic)
						WHERE m.id_msg IN ({array_int:msgids})
							AND a.id_thumb != 0
							AND a.approved = 1
							AND a.mime_type LIKE {string:like}',
						array(
							'msgids' => $msgids,
							'like' => 'IMAGE%'
						)
					);

					$attaches = null;
					while($row = $smcFunc['db_fetch_assoc']($request))
					{
						$attaches[$row['id_msg']][] = array(
							'topic' => $row['id_topic'],
							'image' => $row['id_attach'],
							'thumb' => $row['id_thumb'],
							'fname' => str_replace('_thumb', '', $row['filename'])
						);
					}
					$smcFunc['db_free_result']($request);
				}

				// get boards and views
				$topics = null;
				foreach($posts as $post)
					$topics[] = $post['id'];

				$request = $smcFunc['db_query']('', '
					SELECT b.id_board, b.name, t.id_topic, t.num_views
						FROM {db_prefix}boards b
						LEFT JOIN {db_prefix}topics t ON (t.id_board = b.id_board)
					WHERE t.id_topic IN ({array_int:topics})
						AND t.approved = 1',
					array(
						'topics' => $topics
					)
				);

				$boards = null;
				while($row = $smcFunc['db_fetch_assoc']($request))
				{
					$boards[$row['id_topic']] = array(
						'id_board' => $row['id_board'],
						'boardname' => $row['name'],
						'views' => $row['num_views']
					);
				}
				$smcFunc['db_free_result']($request);

				$is_Split = $this->cfg['config']['settings']['split'];
				$is_last = count($posts);
				$half = ceil($is_last / 2);

				// put the rescale code to the content
				if(!empty($this->cfg['config']['settings']['rescale']))
				{
					$jsImg = 0;
					$this->cfg['content'] = '
					<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[
						var MsgImages'.$this->cfg['id'].' = new Array()';

					for($i = 0; $i < $is_last; $i++)
					{	
						if(empty($context['PortaMx']['settings']['disableHS']) && empty($this->cfg['config']['settings']['disableHS']))
							$posts[$i]['hsbody'] = $posts[$i]['body'];

						if(preg_match_all('~<img[^>]*>~iS', $posts[$i]['body'], $matches) > 0)
						{
							foreach($matches[0] as $data)
							{
								preg_match('~src?=?"([^\"]*\")~i', $data, $src);
								if(isset($src[1]) && strpos($src[1], $modSettings['smileys_url']) === false)
								{
									if(empty($context['PortaMx']['settings']['disableHS']) && empty($this->cfg['config']['settings']['disableHS']))
									{
										$tmp = str_replace($src[0], ' name="pmx'. $this->cfg['id'] .'img'. $jsImg .'" title="'. substr(strrchr($src[1], '/'), 1) .' '. $src[0], $data);
										$posts[$i]['hsbody'] = substr_replace($posts[$i]['hsbody'], 
											'<a href="'. $src[1].' class="highslide" title="'. $txt['pmx_hs_expand'] .'" onclick="return hs.expand(this, {align: \'center\', headingEval: \'this.thumb.title\'})">' .$tmp .'</a>',
											strpos($posts[$i]['hsbody'], $data), strlen($data));
									}
									$tmp = str_replace($src[0], ' name="pmx'. $this->cfg['id'] .'img'. $jsImg .'" '. $src[0], $data);
									$posts[$i]['body'] = substr_replace($posts[$i]['body'], $tmp, strpos($posts[$i]['body'], $data), strlen($data));

									$this->cfg['content'] .= '
						MsgImages'.$this->cfg['id'].'['. $jsImg .'] = "pmx'. $this->cfg['id'] .'img'. $jsImg .'";';
									$jsImg++;
								}
							}
						}
					}
					$this->cfg['content'] .= '
						// ]]></script>';
				}
				else
					$this->cfg['content'] = '';

				// put the data to the content
				$this->cfg['content'] .= '
					<table width="100%" cellpadding="0" cellspacing="0" border="0" style="table-layout:fixed;">
						<tr>
							<td'.($is_Split ? ' style="padding-'.$R_L.':'. $context['PortaMx']['settings']['panels']['padding'] .'px; width:50%;"' : '').' valign="top">';

				reset($posts);
				while(!empty($is_last))
				{
					$post = current($posts);

					if($is_Split && empty($half))
					{
						$this->cfg['content'] .= '
							</td>
							<td style="padding-'.$L_R.':'. $context['PortaMx']['settings']['panels']['padding'] .'px; width:50%;" valign="top">';
						reset($posts);
						next($posts);
						$post = current($posts);
					}
					$half--;
					$is_last--;

					$this->cfg['content'] .= '
								<div id="pmx'.$this->cfg['id'].'bnpos'. $post['message_id'] .'" class="catbg"><span style="padding-bottom:4px;">'. $post['icon'] .'</span>
									<span class="normaltext" style="margin-'.$L_R.':5px; vertical-align:-4px;"><a href="' . $scripturl . '?topic=' . $post['id'] . '.0">'. $post['subject'] .'</a></span>
								</div>
								<div class="smalltext" style="padding-top:3px; float:'.$L_R.';">
									'. $txt['pmx_boardnews_postby'] . $post['poster']['link'] .', '. $post['time'] .'
								</div>
								<div class="smalltext" style="padding-top:3px; float:'.$R_L.';">
									'. $txt['pmx_boardnews_replies'] . $post['replies'] .'
								</div>
								<br style="clear:both;" />
								<div class="smalltext" style="padding-bottom:3px; float:'.$L_R.';">
									'. $txt['pmx_boardnews_board'] .'<a href="' . $scripturl . '?board='. $boards[$post['id']]['id_board'] .'.0">'. $boards[$post['id']]['boardname'] .'</a>
								</div>
								<div class="smalltext" style="padding-bottom:3px; float:'.$R_L.';">
								'. $txt['pmx_boardnews_views'] . $boards[$post['id']]['views'] .'
								</div>
								<hr style="clear:both;" />';

					if(empty($context['PortaMx']['settings']['disableHS']) && empty($this->cfg['config']['settings']['disableHS']))
						$this->cfg['content'] .= '
								<div style="padding-bottom:5px; overflow:hidden;" onmouseover="this.className = \'contentover\'" onmouseout="this.className =\'contentout\'" title="'. $txt['pmx_hs_read'] .'" onclick="return hs.htmlExpand(this, 
										{headingText: \''. addslashes($post['subject']) .'\', maincontentId: \'bn_contid'. $post['message_id'] .'\', align: \'center\', wrapperClassName: \'highslide-wrapper-html\' })">';
					else
						$this->cfg['content'] .= '
								<div style="padding-bottom:5px; overflow:hidden;">';

					if(!empty($this->cfg['config']['settings']['teaser']))
						$this->cfg['content'] .= PortaMx_Tease_posts($post['body'], $this->cfg['config']['settings']['teaser'], empty($this->cfg['config']['settings']['rescale']));
					else
						$this->cfg['content'] .= PortaMx_revoveLinks($post['body'], empty($this->cfg['config']['settings']['rescale']));

					// post has attach?
					$msgattach = '';
					if(isset($attaches[$post['message_id']]))
					{
						$msgattach = '
									<div style="text-align:'.$L_R.'; padding-bottom:5px; margin-top:3px; border-top: 1px dashed gray; overflow:hidden;">';
						$this->cfg['content'] .= $msgattach;

						foreach($attaches[$post['message_id']] as $att)
						{
							$msgattach .= '
										<a href="'. $scripturl .'?action=dlattach;topic='. $post['id'] .'.0;attach='. $att['image'] .';image"  class="highslide" title="'. $txt['pmx_hs_expand'] .'" onclick="return hs.expand(this, {align: \'center\', headingEval: \'this.thumb.title\'})">
											<img align="top" style="padding: 1px;  margin-top:3px;" src="'. $scripturl .'?action=dlattach;topic='. $post['id'] .'.0;attach='. $att['thumb'] .';image" alt="" title="'. $att['fname'] .'" />
										</a>';

							$this->cfg['content'] .= '
										<img align="top" style="padding: 1px; margin-top:3px;" src="'. $scripturl .'?action=dlattach;topic='. $post['id'] .'.0;attach='. $att['thumb'] .';image" alt="'. $att['fname'] .'" title="" />';
						}
						$msgattach .= '
									</div>';
						$this->cfg['content'] .= '
									</div>';
					}

					$this->cfg['content'] .= '
								</div>
								<div class="smalltext" style="padding-bottom:'.(empty($is_last) || empty($half) ? '0' : '4'). 'px;">
									<a href="'. $post['href'] .'">'. $txt['pmx_boardnews_readmore'] .'</a>
								</div>';

					// highslide code
					if(empty($context['PortaMx']['settings']['disableHS']) && empty($this->cfg['config']['settings']['disableHS']))
					{
						$this->cfg['content'] .= '
								<div class="highslide-maincontent" id="bn_contid'. $post['message_id'] .'">';
						if(empty($this->cfg['config']['settings']['rescale']))
							$this->cfg['content'] .= '
									'. PortaMx_revoveLinks($post['body'], empty($this->cfg['config']['settings']['rescale'])) . $msgattach;
						else
							$this->cfg['content'] .= '
									'. PortaMx_revoveLinks($post['hsbody'], empty($this->cfg['config']['settings']['rescale'])) . $msgattach;
						$this->cfg['content'] .= '
								</div>';
					}

					next($posts);
					if($is_Split)
						next($posts);
				}
				$this->cfg['content'] .= '
							</td>
						</tr>
					</table>';

				if(!empty($this->cfg['config']['settings']['rescale']))
					$this->cfg['content'] .= '
					<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[
						MsgImages'.$this->cfg['id'].'['. $jsImg .'] = window.setInterval("ResizeImages(\''.$this->cfg['id'].'\', '. $this->cfg['config']['settings']['rescale'] .')", 20);
					// ]]></script>';
			}
		}
	}
}
?>