<?php
/** 
* @file cbt_navigator.php
* Systemblock cbt_navigator (Categorie-Board-Topic)
*
* @author PortaMx - Portal Management Extension
* @author Copyright 2008-2009 by PortaMx - http://portamx.com
* @Version: 0.957
* @Date: 11.03.2009
*/

if(!defined('PortaMx'))
	die('This file can\'t be run without PortaMx');

/**
* @class pmxc_cbt_navigator
* Systemblock cbt_navigator
* @see cbt_navigator.php
* @author Copyright by PortaMx - http://portamx.com
*/
class pmxc_cbt_navigator extends PortaMxC_SystemBlock
{
	var $boards;		///< all boards

	/**
	* InitContent.
	*/
	function pmxc_InitContent()
	{
		if($this->visible)
		{
			$cstat = $this->pmxc_getCacheStatus();
			if(!empty($cstat) && $cstat < 0)		// refresh need?
			{
				$this->_CBT_Nav();
				$this->pmxc_updateCache();
			}
			elseif(empty($cstat))
				$this->_CBT_Nav();
		}
		// return the visibility flag (true/false)
		return $this->visible;
	}

	/**
	* ShowContent.
	* Output the content and add necessary javascript
	*/
	function pmxc_ShowContent()
	{
		global $context;

		// get boardstate cookie ($found[1] - boardids, $found[2] state)
		if(isset($_COOKIE['pmx'.$this->cfg['id'].'CBTboardstate']))
			preg_match_all('/(\d+)\:(\d+).?/', $_COOKIE['pmx'.$this->cfg['id'].'CBTboardstate'], $found);

		$status = '
						<script type="text/javascript"><!-- // --><![CDATA[
						var cookname = "pmx'.$this->cfg['id'].'CBTboardstate=";';

		if(isset($found[1]) && isset($found[2]) && count($found[1]) == count($found[2]) && count($found[1]) == count($this->boards))
			$status .= '
						var boardIDs = new Array("'. implode('","', $found[1]) .'");
						var boardStats = new Array("'. implode('","', $found[2]) .'");';
		else
			$status .= '
						var boardIDs = new Array("'. implode('","', $this->boards) .'");
						var boardStats = new Array('. substr(str_repeat('"0",', count($this->boards)), 0, -1) .');';

		$isInit = !(isset($found[1]) && count($found[1]) == count($this->boards));

		// Write out the content
		echo $this->cfg['content'];

		echo $status .'
						var cook = "";
						for(var i = 0; i < boardIDs.length; i++)
						{
							var brdid = "pmx'.$this->cfg['id'].'CBTbrd" + boardIDs[i];
							var imgid = "pmx'.$this->cfg['id'].'CBTimg" + boardIDs[i];';

		if($isInit && !empty($this->cfg['config']['settings']['initexpand']))
			echo '
							document.getElementById(brdid).style.display = "";
							document.getElementById(imgid).src = "'. $context['PMx_imageurl'] .'expand.gif";
							cook = cook + boardIDs[i] + ":" + "1|";';

		elseif($isInit && !empty($this->cfg['config']['settings']['initexpandnew']))
			echo '
							var isNew = "pmx'.$this->cfg['id'].'CBTnewimg" + boardIDs[i];
							if(document.getElementById(isNew))
							{
								document.getElementById(brdid).style.display = "";
								document.getElementById(imgid).src = "'. $context['PMx_imageurl'] .'expand.gif";
								cook = cook + boardIDs[i] + ":" + "1|";
							}
							else
								cook = cook + boardIDs[i] + ":" + "0|";';

		else
			echo '
							document.getElementById(brdid).style.display = (boardStats[i] == "0" ? "none" : "");
							document.getElementById(imgid).src = (boardStats[i] == "0" ? "'. $context['PMx_imageurl'] .'upshrink1.gif" : "'. $context['PMx_imageurl'] .'expand.gif");
							cook = cook + boardIDs[i] + ":" + boardStats[i] + "|";';

		echo '
						}
						document.cookie = cookname + cook + "; path=/;";// ]]></script>';
	}

	/**
	* _CBT_Nav.
	* Prepare the values for the content.
	* Fetch all Categories, Boards and Topics.
	*/
	function _CBT_Nav()
	{
		global $context, $smcFunc, $user_info, $modSettings, $settings, $scripturl, $txt;

		if(isset($this->cfg['config']['settings']['recentboards']) && !empty($this->cfg['config']['settings']['recentboards']))
		{
			// get Categories, Board, Topics and Messages .. what a monstrous query ;-) 
			$request = $smcFunc['db_query']('', '
					SELECT c.name AS catname, c.id_cat, 
						b.name AS boardname, b.id_board, b.child_level, b.redirect,
						IFNULL(t.id_topic, 0) AS id_topic, IFNULL(t.id_last_msg, 0) AS id_last_msg, 
						m.id_msg, m.subject, m.poster_name, m.poster_time,
						'. ($user_info['is_guest'] ? '1 AS isRead' : 'IFNULL(lt.id_msg, IFNULL(lmr.id_msg, 0)) >= m.id_msg_modified AS isRead').'
					FROM {db_prefix}boards AS b
					LEFT JOIN {db_prefix}topics AS t ON (t.id_board = b.id_board)
					LEFT JOIN {db_prefix}categories AS c ON (b.id_cat = c.id_cat)
					LEFT JOIN {db_prefix}messages AS m ON (t.id_last_msg = m.id_msg)'. (!$user_info['is_guest'] ? '
					LEFT JOIN {db_prefix}log_topics AS lt ON (t.id_topic = lt.id_topic AND lt.id_member = {int:idmem})
					LEFT JOIN {db_prefix}log_mark_read AS lmr ON (lmr.id_board = m.id_board AND lmr.id_member = {int:idmem})' : '').'
					WHERE b.id_board IN ({array_int:boards}) AND '. $user_info['query_wanna_see_board'] .'
					'. ($modSettings['postmod_active'] ? ' AND m.approved = {int:approv}' : '') .'
          AND (b.id_last_msg = m.id_msg OR t.id_last_msg >= {int:min_msg} OR t.id_last_msg IS NULL)
					ORDER BY c.cat_order ASC, b.board_order ASC, t.id_board ASC, m.poster_time DESC',
				array(
					'idmem' => $user_info['id'],
					'boards' => $this->cfg['config']['settings']['recentboards'],
					'min_msg' => $modSettings['maxMsgID'] - 100 * $this->cfg['config']['settings']['numrecent'],
					'approv' => 1,
				)
			);

			// now sort out all the records
			$bID = 0;
			$cID = 0;
			$this->boards = array();
			$cat_board = array();
			$topics = array();

			$rowsRead = $smcFunc['db_num_rows']($request);

			while($row = $smcFunc['db_fetch_assoc']($request))
			{
				// new categorie ?
				if($cID != $row['id_cat'])
				{
					// yes, save topics from previous cat / board
					if(!empty($cID) && !empty($bID))
					{
						$cat_board[$cID]['boards'][$bID]['topics'] = $topics;
						$cat_board[$cID]['boards'][$bID]['unread'] = $unreadmsg;
						$topics = array();
					}

					// save the new cat
					$cID = $row['id_cat'];
					$cat_board[$cID]['name'] = $row['catname'];
					$cat_board[$cID]['short_name'] = $this->_txt_shorten($row['catname'], $this->cfg['config']['settings']['numlen']);
					$bID = 0;
				}

				// same categorie ?
				if($cID == $row['id_cat'])
				{
					// yes, new board?
					if($bID != $row['id_board'])
					{
						// yes, save topics from previous board
						if(!empty($bID))
						{
							$cat_board[$cID]['boards'][$bID]['topics'] = $topics;
							$cat_board[$cID]['boards'][$bID]['unread'] = $unreadmsg;
              $topics = array();
						}

						// save the new board
						$bID = $row['id_board'];
						if(empty($row['redirect']) && !empty($row['id_topic']))
							$this->boards[] = $bID;

						$cat_board[$cID]['boards'][$bID] = array(
							'name' => $row['boardname'],
							'level' => $row['child_level'],
							'isredir' => !empty($row['redirect']),
							'hastopics' => !empty($row['id_topic']),
						);

						// setup the topic count
						$count = (!empty($row['id_topic']) ? $this->cfg['config']['settings']['numrecent'] : 0);
						$unreadmsg = 0;
					}
				}

				// count the topics
				if($count > 0)
				{
					censorText($row['subject']);
					$topics[$row['id_topic']] = array(
						'subject' => $row['subject'],
						'short_subject' => $this->_txt_shorten($row['subject'], empty($row['isRead']) ? $this->cfg['config']['settings']['numlen'] - (4 +($row['child_level'] * 2)) : $this->cfg['config']['settings']['numlen'] - (3 +($row['child_level'] * 2))),
						'post_name' => $row['poster_name'],
						'post_time' => strip_tags(timeformat($row['poster_time'])),
						'id_msg' => $row['id_msg'],
						'last_msg' => $row['id_last_msg'],
						'isRead' => $row['isRead'],
					);
					$unreadmsg = ($row['isRead'] ? $unreadmsg : 1);
					$count --;
				}
			}

			// save last topics
			if(!empty($bID))
			{
				$cat_board[$cID]['boards'][$bID]['topics'] = $topics;
				$cat_board[$cID]['boards'][$bID]['unread'] = $unreadmsg;
			}

			// done
			$smcFunc['db_free_result']($request);

			// Now make the content
			$this->cfg['content'] = '
					<script type="text/javascript"><!-- // --><![CDATA[
						function NavCatToggle(elm, brdidname, brdid)
						{
							var cstat = document.getElementById(brdidname).style.display;
							var img = (cstat == "none" ? "'. $context['PMx_imageurl'] .'expand.gif" : "'. $context['PMx_imageurl'] .'upshrink1.gif");
							var state = (cstat == "none" ? "" : "none");
							elm.src = img;
							document.getElementById(brdidname).style.display = state;
							var cook = "";
							for(var i = 0; i < boardIDs.length; i++)
							{
								if(boardIDs[i] == brdid)
									boardStats[i] = (cstat == "none" ? "1" : "0");
								cook = cook + boardIDs[i] + ":" + boardStats[i] + "|";
							}
							document.cookie = cookname + cook +"; path=/;";
						}
						function NavCatToggleALL(mode)
						{
							var cook = "";
							for(var i = 0; i < boardIDs.length; i++)
							{
								var brdid = "pmx'.$this->cfg['id'].'CBTbrd" + boardIDs[i];
								var imgid = "pmx'.$this->cfg['id'].'CBTimg" + boardIDs[i];
								document.getElementById(brdid).style.display = (mode == 0 ? "none" : "");
								document.getElementById(imgid).src = (mode == 0 ? "'. $context['PMx_imageurl'] .'upshrink1.gif" : "'. $context['PMx_imageurl'] .'expand.gif");
								boardStats[i] = mode;
								cook = cook + boardIDs[i] + ":" + boardStats[i] + "|";
							}
							document.cookie = cookname + cook +"; path=/;";
						}// ]]></script>';

			$this->cfg['content'] .= '
					<div>
						<a href="javascript:void(\'\')" style="float:'. (empty($context['right_to_left']) ? 'left' : 'right') .';" onclick="NavCatToggleALL(1)">'. $txt['pmx_cbt_expandall'] .'</a>
						<a href="javascript:void(\'\')" style="float:'. (empty($context['right_to_left']) ? 'right' : 'left') .';" onclick="NavCatToggleALL(0)">'. $txt['pmx_cbt_collapseall'] .'</a>
					</div>
					<br style="clear:both; line-height:1px;" />
					<hr style="margin-top:'. ($context['browser']['is_ie'] ? '-3' : '3') .'px;" />
					<div style="margin-top: -3px;">';
			// loop through all cats, boards and topics
			foreach($cat_board as $cid => $cats)
			{
				if(!empty($cats['boards']))
				{
					$this->cfg['content'] .= '
						<div><a href="'. $scripturl .'?action=forum;#c'. $cid .'" title="'. $txt['pmx_cbt_categorie'] . $cats['name'] .'"><b>'. $cats['short_name'].'</b></a></div>';

					foreach($cats['boards'] as $bid => $board)
					{
						$board_shortname = $this->_txt_shorten($board['name'], empty($board['unread']) ? $this->cfg['config']['settings']['numlen'] - (2 + ($board['level'] *3)) : $this->cfg['config']['settings']['numlen'] - (3 + ($board['level'] *3)));
						$this->cfg['content'] .= '
						<div style="margin-bottom:-2px; padding-'. (empty($context['right_to_left']) ? 'left' : 'right') .':'.($board['level'] * 8).'px;">';
						
						if($board['isredir'] || empty($board['hastopics']))
							$this->cfg['content'] .= '
							<img src="'. $context['PMx_imageurl'] . ($board['isredir'] ? 'redir' : 'notopic') .'.gif" alt="*" title="" />';
						else
							$this->cfg['content'] .= '
							<img id="pmx'.$this->cfg['id'].'CBTimg'.$bid.'" onclick="NavCatToggle(this, \'pmx'.$this->cfg['id'].'CBTbrd'.$bid.'\', '. $bid .')" src="'. $context['PMx_imageurl'] .'upshrink1.gif" alt="*" title="'. $txt['pmx_cbt_colexp'] . $board['name'] .'" style="cursor:pointer;" />';

						$this->cfg['content'] .= '
							<span style="vertical-align:2px;"><a href="'. $scripturl .'?board='. $bid .'.0" title="'. $txt['pmx_cbt_board'] . $board['name'] .'">'. $board_shortname .'</a>'.($board['unread'] ? '<img id="pmx'.$this->cfg['id'].'CBTnewimg'. $bid .'" src="'. $context['PMx_imageurl'] .'unread.gif" alt="*" title="" />' : '').'</span>
						</div>';

						if($board['hastopics'])
						{
							$this->cfg['content'] .= '
						<div id="pmx'.$this->cfg['id'].'CBTbrd'.$bid.'" style="margin-bottom:2px; display:none">';

							foreach($board['topics'] as $tid => $topic)
							{
								$short_subject = $this->_txt_shorten($topic['subject'], empty($topic['isRead']) ? $this->cfg['config']['settings']['numlen'] - (4 +($board['level'] * 2)) : $this->cfg['config']['settings']['numlen'] - (3 +($board['level'] * 2)));
								$ttl = $txt['pmx_cbt_topic'] . $topic['subject'] .' '. $txt['by'] .' '. $topic['post_name'] .', '. $topic['post_time'];
								$this->cfg['content'] .= '
							<div style="padding-'. (empty($context['right_to_left']) ? 'left' : 'right') .':'.(17 + ($board['level'] * 5)).'px;"><a href="'. $scripturl .'?topic='. $tid .'.msg'. $topic['id_msg'] .';topicseen#new" title="'. $ttl .'">'. $short_subject .'</a>'. (empty($topic['isRead']) ? '<img src="'. $context['PMx_imageurl'] .'unread.gif" alt="*" title="" />' : '').'</div>';
							}

							$this->cfg['content'] .= '
						</div>';
						}
					}
				}
			}
				// done
			$this->cfg['content'] .= '
					</div>';
		}
	}

	/**
	* _txt_shorten.
	* create a shorten subject
	*/
	function _txt_shorten($value, $len)
	{
		if($len <= 0)
			return $value;
//		$found = preg_match_all('~(i|l|:)~', $value, $tmp);
		$tmp = substr($value, 0, $len); //($len + round($found / 2)));
		if(strlen($value) != strlen($tmp))
			$tmp .= '..';
		return $tmp;
	}
}
?>