<?php
/** 
* @file cbt_navigator_adm.php
* Admin Systemblock cbt_navigator (Categorie-Board-Topic)
*
* @author PortaMx - Portal Management Extension
* @author Copyright 2008-2009 by PortaMx - http://portamx.com
* @Version: 0.957
* @Date: 11.03.2009
*/

if(!defined('PortaMx'))
	die('This file can\'t be run without PortaMx');

global $context, $txt;

/// Registerblock setup (description & icon)
$context['PortaMx']['RegisterBlocks']['cbt_navigator'] = array(
		'description' => $txt['pmx_cbt_navigator_description'],
		'blocktype' => $txt['pmx_sysblock'],
		'icon' => 'system',
);

/**
* @class pmxc_cbt_navigator_adm
* Admin Systemblock cbt_navigator_adm
* @see cbt_navigator_adm.php
* @author Copyright by PortaMx - http://portamx.com
*/
class pmxc_cbt_navigator_adm extends PortaMxC_SystemAdminBlock
{
	/**
	* AdmBlock_init().
	* Setup caching and returns the language file name.
	*/
	function pmxc_AdmBlock_init()
	{
		$this->can_cached = 0;			// disable caching
		return 'cbt_navigator';			// language
	}

	/**
	* AdmBlock_settings().
	* Setup the config vars and output the block settings.
	* Returns the css classes they are used.
	*/
	function pmxc_AdmBlock_settings()
	{
		global $context, $txt;

		// define the settings options
		echo '
					<td valign="top" style="padding:4px;">
						<input type="hidden" name="config[langfile]" value="'. $this->cfg['config']['langfile'] .'" />
						<input type="hidden" name="config[settings]" value="" />';

		// define numeric vars to check
		echo '
						<input type="hidden" name="check_num_vars[]" value="[config][settings][numrecent], 5" />
						<input type="hidden" name="check_num_vars[]" value="[config][settings][numlen], 20" />';

		// show the settings screen
		echo '
						<div class="titlebg adm_titlebar">'. $txt['pmx_cbtnavbox_title'] .'</div>

						<div class="adm_input" style="height:20px;">
							<span class="adm_w80">'. $txt['pmx_cbtnavnum'] .'</span>
							<div><input onkeyup="check_numeric(this);" size="2" type="text" name="config[settings][numrecent]" value="' .(isset($this->cfg['config']['settings']['numrecent']) ? $this->cfg['config']['settings']['numrecent'] : '5'). '" /></div>
						</div>
						<div class="adm_input" style="height:20px;">
							<span class="adm_w80">'. $txt['pmx_cbtnavlen'] .'
								<img class="info_toggle" onclick=\'Show_help("pmxCBTH01")\' src="'. $context['PMx_imageurl'] .'information.gif" alt="*" title="'. $txt['pmx_information_icon'] .'" />
							</span>
							<div><input onkeyup="check_numeric(this);" size="2" type="text" name="config[settings][numlen]" value="' .(isset($this->cfg['config']['settings']['numlen']) ? $this->cfg['config']['settings']['numlen'] : '20'). '" /></div>
						</div>
						<div id="pmxCBTH01" class="info_frame" style="margin-top:4px;">'. $txt['pmx_cbt_shorten_hint'] .'</div>
						<div class="adm_check" style="height:20px;">
							<input type="hidden" name="config[settings][initexpand]" value="0" />
							<span class="adm_w80">'. $txt['pmx_cbtnavexpand'] .'</span>
							<div><input class="check" type="checkbox" name="config[settings][initexpand]" value="1"' .(isset($this->cfg['config']['settings']['initexpand']) && $this->cfg['config']['settings']['initexpand'] == 1 ? ' checked="checked"' : ''). ' /></div>
						</div>
						<div class="adm_check" style="height:20px;">
							<input type="hidden" name="config[settings][initexpandnew]" value="0" />
							<span class="adm_w80">'. $txt['pmx_cbtnavexpandnew'] .'</span>
							<div><input class="check" type="checkbox" name="config[settings][initexpandnew]" value="1"' .(isset($this->cfg['config']['settings']['initexpandnew']) && $this->cfg['config']['settings']['initexpandnew'] == 1 ? ' checked="checked"' : ''). ' /></div>
						</div>
						<div class="adm_input">
							<span>'. $txt['pmx_cbtnavboards'] .'</span>
							<select class="adm_w90" name="config[settings][recentboards][]" multiple="multiple" size="8">';

		$boards = isset($this->cfg['config']['settings']['recentboards']) ? $this->cfg['config']['settings']['recentboards'] : array();
		foreach($this->smf_boards as $brd)
			echo '
								<option value="'. $brd['id'] .'"'. (in_array($brd['id'], $boards) ? ' selected="selected"' : '') .'>'. $brd['name'] .'</option>';

		echo '
							</select>
						</div>
					</td>';

		// return the default classnames
		return $this->block_classdef;
	}
}
?>