<?php
/** 
* @file download.php
* Systemblock Downlaod
*
* @author PortaMx - Portal Management Extension
* @author Copyright 2008-2009 by PortaMx - http://portamx.com
* @Version: 0.957
* @Date: 11.03.2009
*/

if(!defined('PortaMx'))
	die('This file can\'t be run without PortaMx');

/**
* @class pmxc_download
* Systemblock Download
* @see download.php
* @author Copyright by PortaMx - http://portamx.com
*/
class pmxc_download extends PortaMxC_SystemBlock
{
	/**
	* InitContent.
	* Checks the cache status and create the content.
	* Also the SessionVar ['pxmcontent_refresh'] is checked for refresh.
	*/
	function pmxc_InitContent()
	{
		global $context;

		if($this->visible)
		{
			$cstat = $this->pmxc_getCacheStatus();
			if(!empty($cstat) && $cstat < 0 || isset($_SESSION['pxmcontent_refresh'][$this->cfg['blocktype']]))	// refresh need?
			{
				if(isset($_SESSION['pxmcontent_refresh'][$this->cfg['blocktype']]))
					unset($_SESSION['pxmcontent_refresh'][$this->cfg['blocktype']]);

				$this->_DownloadContent();
				$this->pmxc_updateCache();
			}
			elseif(empty($cstat))
				$this->_DownloadContent();
		}
		// return the visibility flag (true/false)
		return $this->visible;
	}

	/**
	* _DownloadContent.
	* Prepare the content and save in $this->cfg['content'].
	*/
	function _DownloadContent()
	{
		global $smcFunc, $context, $user_info, $scripturl, $txt;

		$L_R = empty($context['right_to_left']) ? 'left' : 'right';
		$R_L = empty($context['right_to_left']) ? 'right' : 'left';

		$phpcount = preg_match_all('~<(\?)(php)(.*)\\1>~ims', $this->cfg['config']['html'], $matches, PREG_PATTERN_ORDER);
		if($phpcount != 0)
		{
			for($i=0; $i < $phpcount; $i++)
				$this->cfg['config']['html'] = str_replace($matches[0][$i], eval($matches[3][$i]), $this->cfg['config']['html']);
		}

		$this->cfg['content'] = '
					'. parse_bbc($this->cfg['config']['html']);

		if(isset($this->cfg['config']['settings']['download_board']) && !empty($this->cfg['config']['settings']['download_board']))
		{
			// save the access groups
			$_SESSION['pxm_download_acs'][$this->cfg['id']] = $this->cfg['config']['settings']['download_acs'];

			// get downloads for board
			$request = $smcFunc['db_query']('', '
					SELECT a.id_attach, a.size, a.downloads, t.id_topic, t.locked, m.subject, m.body,
					IF(m.subject REGEXP \'^[0-9 ]{4}\', CAST(LEFT(m.subject, 4) AS UNSIGNED), 0) AS file_order
					FROM {db_prefix}attachments a
					LEFT JOIN {db_prefix}messages m ON (a.id_msg = m.id_msg)
					LEFT JOIN {db_prefix}topics t ON (m.id_topic = t.id_topic)
					WHERE m.id_board = {int:board}
					AND a.mime_type NOT LIKE {string:likestr} AND t.locked = 0
					ORDER BY file_order ASC',
				array(
					'board' => $this->cfg['config']['settings']['download_board'],
					'likestr' => 'IMAGE%'
				)
			);

			$entrys = $smcFunc['db_num_rows']($request);
			if($entrys > 0)
			{
				while($row = $smcFunc['db_fetch_assoc']($request))
				{
					$this->cfg['content'] .= '
					<div style="text-align:'. $L_R .';">
						<a href="'. $scripturl .'?action=dlattach;id='. $row['id_attach'] .';fld='. $this->cfg['id'] .'">
							<strong>'. (empty($row['file_order']) ? $row['subject'] : substr($row['subject'], 4)) .'</strong>
						</a>
						<div class="dlcomment">'. parse_bbc(trim($row['body'])) .'</div>';
					if($user_info['is_admin'])
						$this->cfg['content'] .= '
						<a href="'. $scripturl .'?topic='. $row['id_topic'] .'"><b>['. ceil($row['size'] / 1024) .'</b> '. $txt['pmx_kb_downloads'] .'<b>'. $row['downloads'] .'</b>]</a>';
					else
						$this->cfg['content'] .= '
						<b>['. ceil($row['size'] / 1024) .'</b> '. $txt['pmx_kb_downloads'] .'<b>'. $row['downloads'] .'</b>]';
					$this->cfg['content'] .= '
					</div>' . ($entrys > 1 ? '<hr />' : '');
					$entrys--;
				}
				$smcFunc['db_free_result']($request);
			}
			else
				$this->cfg['content'] .= $txt['pmx_download_empty'];
		}
		else
			$this->cfg['content'] .= $txt['pmx_download_empty'];
	}
}
?>