<?php
/** 
* @file download_adm.php
* Admin Systemblock download
*
* @author PortaMx - Portal Management Extension
* @author Copyright 2008-2009 by PortaMx - http://portamx.com
* @Version: 0.957
* @Date: 11.03.2009
*/

if(!defined('PortaMx'))
	die('This file can\'t be run without PortaMx');

global $context, $txt;

/// Registerblock setup (description & icon)
$context['PortaMx']['RegisterBlocks']['download'] = array(
		'description' => $txt['pmx_download_description'],
		'blocktype' => $txt['pmx_sysblock'],
		'icon' => 'system',
);

/**
* @class pmxc_download_adm
* Admin Systemblock download_adm
* @see download_adm.php
* @author Copyright by PortaMx - http://portamx.com
*/
class pmxc_download_adm extends PortaMxC_SystemAdminBlock
{
	/**
	* AdmBlock_init().
	* Setup caching and returns the language file name.
	*/
	function pmxc_AdmBlock_init()
	{
		$this->can_cached = 1;		// enable caching
		return 'download';				// language
	}

	/**
	* AdmBlock_settings().
	* Setup the config vars and output the block settings.
	* Returns the css classes they are used.
	*/
	function pmxc_AdmBlock_settings()
	{
		global $context, $txt;

		// define the settings options
		echo '
					<td valign="top" style="padding:4px;">
						<input type="hidden" name="config[langfile]" value="'. $this->cfg['config']['langfile'] .'" />
						<input type="hidden" name="config[settings]" value="" />';

		// show the settings screen
		echo '
						<div class="titlebg adm_titlebar">'. $txt['pmx_download_title'] .'</div>

						<div class="adm_input">
							<span>'. $txt['pmx_download_board'] .'</span>
							<select class="adm_w90" name="config[settings][download_board]">';

		$board = isset($this->cfg['config']['settings']['download_board']) ? $this->cfg['config']['settings']['download_board'] : 0;
		foreach($this->smf_boards as $brd)
			echo '
								<option value="'. $brd['id'] .'"'. ($brd['id'] == $board ? ' selected="selected"' : '') .'>'. $brd['name'] .'</option>';

		echo '
							</select>
						</div>

						<div class="adm_input">
							<span>'. $txt['pmx_download_groups'] .'</span>
							<input type="hidden" name="config[settings][download_acs][]" value="" />
							<select class="adm_w90" name="config[settings][download_acs][]" multiple="multiple" size="5">';

		foreach($this->smf_groups as $grp)
			echo '
								<option value="'. $grp['id'] .'"'. (!empty($this->cfg['config']['settings']['download_acs']) && in_array($grp['id'], $this->cfg['config']['settings']['download_acs']) ? ' selected="selected"' : '') .'>'. $grp['name'] .'</option>';
		echo '
							</select>
						</div>
					</td>';

		// return the used classnames
		return $this->block_classdef;
	}

	/**
	* AdmBlock_content().
	* Load the BBC Editor, to create or edit the content.
	* Returns the AdmBlock_settings
	*/
	function pmxc_AdmBlock_content()
	{
		global $context, $txt;

		// show the content area
		echo '
					<td valign="top" colspan="2" style="padding:4px;">
						<div class="titlebg adm_center_titlebar">'. $txt['pmx_edit_content'] .'</div>';

		if(empty($context['PortaMx']['settings']['manager']['edit_bbc']))
		{
						// load the wysiwyg editor
						$content = isset($this->cfg['config']['html']) ? $this->cfg['config']['html'] : '';
						PortaMx_EditContent_xhtml('config[html]', $content, 'Default', '250');

			echo '
					</td>
				</tr>
				<tr class="windowbg">';
		}
		else
		{
			echo '
						<div style="padding:5px;">
							', template_control_richedit($context['PortaMx']['editorID'], 'bbc'), '
						</div>
						<div style="padding:5px;">
							', template_control_richedit($context['PortaMx']['editorID'], 'smileys'), '
						</div>
						<div style="padding:5px;">
							', template_control_richedit($context['PortaMx']['editorID'], 'message'), '
						</div>
					</td>
				</tr>
				<tr class="windowbg">';

				// If the BBC WYSIWYG editor available and active on save, we need a special handling.
				// The doSubmit() copied the html back to the textarea and we send a html_to_bbc.
				// On this, the Post handler convert the html back to bbc code.
				echo '
				<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[
					function PmX_RichEdit_Submit()
					{ 
						if(editorHandle'. $context['PortaMx']['editorID'].'.bRichTextPossible && editorHandle'. $context['PortaMx']['editorID'].'.bRichTextEnabled)
						{
							editorHandle'. $context['PortaMx']['editorID'].'.doSubmit();
							document.getElementById("extra_cmd").name = "html_to_bbc";
							document.getElementById("extra_cmd").value = "1";
						}
					}
				// ]]></script>';
		}

		// return the default settings
		return $this->pmxc_AdmBlock_settings();
	}
}
?>