<?php
/** 
* @file newposts_adm.php
* Admin Systemblock newposts
*
* @author PortaMx - Portal Management Extension
* @author Copyright 2008-2009 by PortaMx - http://portamx.com
* @Version: 0.957
* @Date: 11.03.2009
*/

if(!defined('PortaMx'))
	die('This file can\'t be run without PortaMx');

global $context, $txt;

/// Registerblock setup (description & icon)
$context['PortaMx']['RegisterBlocks']['newposts'] = array(
		'description' => $txt['pmx_newposts_description'],
		'blocktype' => $txt['pmx_sysblock'],
		'icon' => 'system',
);

/**
* @class pmxc_newposts_adm
* Admin Systemblock newposts_adm
* @see newposts_adm.php
* @author Copyright by PortaMx - http://portamx.com
*/
class pmxc_newposts_adm extends PortaMxC_SystemAdminBlock
{
	/**
	* AdmBlock_init().
	* Setup caching and returns the language file name.
	*/
	function pmxc_AdmBlock_init()
	{
		$this->can_cached = 0;		// disable caching
		return 'newposts';				// language
	}

	/**
	* AdmBlock_settings().
	* Setup the config vars and output the block settings.
	* Returns the css classes they are used.
	*/
	function pmxc_AdmBlock_settings()
	{
		global $context, $txt;

		// define the settings options
		echo '
					<td valign="top" style="padding:4px;">
						<input type="hidden" name="config[langfile]" value="'. $this->cfg['config']['langfile'] .'" />
						<input type="hidden" name="config[settings]" value="" />';

		// define numeric vars to check
		echo '
						<input type="hidden" name="check_num_vars[]" value="[config][settings][total], 10" />
						<input type="hidden" name="check_num_vars[]" value="[config][settings][teaser], 40" />';

		// show the settings screen
		echo '
						<div class="titlebg adm_titlebar">'. $txt['pmx_newposts_title'] .'</div>

						<div class="adm_input">
							<span>'. $txt['pmx_newposts_boards'] .'</span>
							<select class="adm_w90" name="config[settings][boards][]" multiple="multiple" size="6">';

		$boards = isset($this->cfg['config']['settings']['boards']) ? $this->cfg['config']['settings']['boards'] : array();
		foreach($this->smf_boards as $brd)
			echo '
								<option value="'. $brd['id'] .'"'. (in_array($brd['id'], $boards) ? ' selected="selected"' : '') .'>'. $brd['name'] .'</option>';

		echo '
							</select>
						</div>

						<div class="adm_input" style="height:20px; margin-top:4px;">
							<span class="adm_w80">'. $txt['pmx_newposts_total'] .'</span>
							<div><input onkeyup="check_numeric(this);" size="2" type="text" name="config[settings][total]" value="' .(isset($this->cfg['config']['settings']['total']) ? $this->cfg['config']['settings']['total'] : '10'). '" /></div>
						</div>

						<div class="adm_input" style="min-height:20px;">
							<span class="adm_w80">'. $txt['pmx_newposts_teaser'] .'
								<img class="info_toggle" onclick=\'Show_help("pmxNPH01")\' src="'. $context['PMx_imageurl'] .'information.gif" alt="*" title="'. $txt['pmx_information_icon'] .'" />
							</span>
							<div><input onkeyup="check_numeric(this);" size="2" type="text" name="config[settings][teaser]" value="' .(isset($this->cfg['config']['settings']['teaser']) ? $this->cfg['config']['settings']['teaser'] : '40'). '" /></div>
							<div id="pmxNPH01" class="info_frame" style="margin-top:2px;">'. $txt['pxm_newposts_teasehelp'] .'</div>
						</div>

						<div class="adm_input" style="height:20px;">
							<span class="adm_w80">'. $txt['pmx_newposts_rescale'] .'
								<img class="info_toggle" onclick=\'Show_help("pmxNPH02")\' src="'. $context['PMx_imageurl'] .'information.gif" alt="*" title="'. $txt['pmx_information_icon'] .'" />
							</span>
							<div><input onkeyup="check_numeric(this);" size="3" type="text" name="config[settings][rescale]" value="' .(isset($this->cfg['config']['settings']['rescale']) ? $this->cfg['config']['settings']['rescale'] : '0'). '" /></div>
						</div>
						<div id="pmxNPH02" class="info_frame" style="margin-top:4px;">'. $txt['pxm_newposts_rescalehelp'] .'</div>

						<div class="adm_check" style="height:20px;">
							<span class="adm_w80">'. $txt['pmx_newposts_showthumbs'] .'</span>
							<input type="hidden" name="config[settings][thumbs]" value="0" />
							<div><input class="check" type="checkbox" name="config[settings][thumbs]" value="1"' .(isset($this->cfg['config']['settings']['thumbs']) && !empty($this->cfg['config']['settings']['thumbs']) ? ' checked="checked"' : ''). ' /></div>
						</div>

						<div class="adm_check" style="height:20px;">
							<span class="adm_w80">'. $txt['pmx_newposts_split'] .'</span>
							<input type="hidden" name="config[settings][split]" value="0" />
							<div><input class="check" type="checkbox" name="config[settings][split]" value="1"' .(isset($this->cfg['config']['settings']['split']) && !empty($this->cfg['config']['settings']['split']) ? ' checked="checked"' : ''). ' /></div>
						</div>';

		if(empty($context['PortaMx']['settings']['disableHS']))
			echo '
						<div class="adm_check" style="height:20px;">
							<span class="adm_w80">'. $txt['pmx_newposts_disableHS'] .'</span>
							<input type="hidden" name="config[settings][disableHS]" value="0" />
							<div><input class="check" type="checkbox" name="config[settings][disableHS]" value="1"' .(isset($this->cfg['config']['settings']['disableHS']) && !empty($this->cfg['config']['settings']['disableHS']) ? ' checked="checked"' : ''). ' /></div>
						</div>';
		echo '
					</td>';

		// return the used classnames
		return $this->block_classdef;
	}
}
?>
