<?php
/** 
* @file recent_posts.php
* Systemblock recent_posts
*
* @author PortaMx - Portal Management Extension
* @author Copyright 2008-2009 by PortaMx - http://portamx.com
* @Version: 0.957
* @Date: 11.03.2009
*/

if(!defined('PortaMx'))
	die('This file can\'t be run without PortaMx');

/**
* @class pmxc_recent_posts
* Systemblock recent_posts
* @see recent_posts.php
* @author Copyright by PortaMx - http://portamx.com
*/
class pmxc_recent_posts extends PortaMxC_SystemBlock
{
	/**
	* InitContent.
	* Checks the cache status and create the content.
	*/
	function pmxc_InitContent()
	{
		if($this->visible)
		{
			$cstat = $this->pmxc_getCacheStatus();
			if(!empty($cstat) && $cstat < 0)		// refresh need?
			{
				$this->_RecentContent();
				$this->pmxc_updateCache();
			}
			elseif(empty($cstat))
				$this->_RecentContent();
		}
		// return the visibility flag (true/false)
		return $this->visible;
	}

	/**
	* _RecentContent.
	* Prepare the content and save in $this->cfg['content'].
	*/
	function _RecentContent()
	{
		global $context, $scripturl, $settings, $txt;

		$this->cfg['content'] = '';
		if(isset($this->cfg['config']['settings']['recentboards']) && !empty($this->cfg['config']['settings']['recentboards']))
		{
			$posts = ssi_recentPosts($this->cfg['config']['settings']['numrecent'], null, $this->cfg['config']['settings']['recentboards'], '');

			if(!empty($posts))
			{
				$numpost = count($posts);
				// put the data on the content
				foreach($posts as $post)
				{
					$numpost--;

					$this->cfg['content'] .= '
									<a href="'. $post['href'] .'">'. $post['subject'] .'</a><br />
									'.(empty($context['right_to_left']) ? $txt['by'] .' '. $post['poster']['link'] : $post['poster']['link'] .' '. $txt['by']).'<br />
									'. ($post['new'] ? '' : '<a href="' . $scripturl . '?topic=' . $post['topic'] . '.msg' . $post['new_from'] . ';topicseen#new" rel="nofollow"><img src="' . $settings['lang_images_url'] . '/new.gif" alt="' . $txt['new'] . '" border="0" /></a> ').
									'['. $post['time'] .']'. ($numpost > 0 ? '
									<hr />' : '');
				}
			}
		}
	}
}
?>