<?php
/** 
* @file recent_posts_adm.php
* Admin Systemblock recent_posts
*
* @author PortaMx - Portal Management Extension
* @author Copyright 2008-2009 by PortaMx - http://portamx.com
* @Version: 0.957
* @Date: 11.03.2009
*/

if(!defined('PortaMx'))
	die('This file can\'t be run without PortaMx');

global $context, $txt;

/// Registerblock setup (description & icon)
$context['PortaMx']['RegisterBlocks']['recent_posts'] = array(
		'description' => $txt['pmx_recent_post_description'],
		'blocktype' => $txt['pmx_sysblock'],
		'icon' => 'system',
);

/**
* @class pmxc_recent_posts_adm
* Admin Systemblock recent_posts_adm
* @see recent_posts_adm.php
* @author Copyright by PortaMx - http://portamx.com
*/
class pmxc_recent_posts_adm extends PortaMxC_SystemAdminBlock
{
	/**
	* AdmBlock_init().
	* Setup caching and returns the language file name.
	*/
	function pmxc_AdmBlock_init()
	{
		$this->can_cached = 0;			// disable caching
		return 'recent_posts';			// language
	}

	/**
	* AdmBlock_settings().
	* Setup the config vars and output the block settings.
	* Returns the css classes they are used.
	*/
	function pmxc_AdmBlock_settings()
	{
		global $context, $txt;

		// define the settings options
		echo '
					<td valign="top" style="padding:4px;">
						<input type="hidden" name="config[langfile]" value="'. $this->cfg['config']['langfile'] .'" />
						<input type="hidden" name="config[settings]" value="" />';

		// define numeric vars to check
		echo '
						<input type="hidden" name="check_num_vars[]" value="[config][settings][numrecent], 5" />';

		// show the settings screen
		echo '
						<div class="titlebg adm_titlebar">'. $txt['pmx_recentpostbox_title'] .'</div>

						<div class="adm_input">
							<span class="adm_w80">'. $txt['pmx_recentpostnum'] .'</span>
							<div><input onkeyup="check_numeric(this);" size="2" type="text" name="config[settings][numrecent]" value="' .(isset($this->cfg['config']['settings']['numrecent']) ? $this->cfg['config']['settings']['numrecent'] : '5'). '" /></div>
						</div>

						<div class="adm_input">
							<span>'. $txt['pmx_recentpostboards'] .'</span>
							<select class="adm_w90" name="config[settings][recentboards][]" multiple="multiple" size="8">';

		$boards = isset($this->cfg['config']['settings']['recentboards']) ? $this->cfg['config']['settings']['recentboards'] : array();
		foreach($this->smf_boards as $brd)
			echo '
								<option value="'. $brd['id'] .'"'. (in_array($brd['id'], $boards) ? ' selected="selected"' : '') .'>'. $brd['name'] .'</option>';

		echo '
							</select>
						</div>
					</td>';

		// return the default classnames
		return $this->block_classdef;
	}
}
?>