<?php
/** 
* @file rss_reader.php
* Systemblock RSS Feed Reader
*
* @author PortaMx - Portal Management Extension
* @author Copyright 2008-2009 by PortaMx - http://portamx.com
* @Version: 0.957
* @Date: 11.03.2009
*/

if(!defined('PortaMx'))
	die('This file can\'t be run without PortaMx');

/**
* @class pmxc_rss_reader
* Systemblock RSS Feed Reader
* @see rss_reader.php
* @author Copyright by PortaMx - http://portamx.com
*/
class pmxc_rss_reader extends PortaMxC_SystemBlock
{
	var $TimeToLife;		///< Feed TTL if send

	/**
	* InitContent.
	* Checks the cache status and create the content.
	*/
	function pmxc_InitContent()
	{
		if($this->visible)
		{
			$cstat = $this->pmxc_getCacheStatus();
			if(!empty($cstat) && $cstat < 0)		// refresh need?
			{
				if($this->_rssreaderContent())
				{
					if(!empty($this->TimeToLife))
						$this->pmxc_updateCache($this->TimeToLife, true);
					else
						$this->pmxc_updateCache();
        }
			}
			elseif(empty($cstat))
			{
				if($this->_rssreaderContent())
				{
					if(!empty($this->TimeToLife))
						$this->pmxc_updateCache($this->TimeToLife, true);
				}
			}
		}
		// return the visibility flag (true/false)
		return $this->visible;
	}

	/**
	* _rssreaderContent.
	* Prepare the content and save in $this->cfg['content'].
	*/
	function _rssreaderContent()
	{
		global $context, $txt;

		$L_R = empty($context['right_to_left']) ? 'left' : 'right';
		$R_L = empty($context['right_to_left']) ? 'right' : 'left';
    $ret = false;
		$this->TimeToLife = 0;

		if(!empty($this->cfg['config']['settings']['rssfeedurl']))
		{
			// get All posts from feed
			$feedpost = getRSSfeedPosts($feedheader, $this->cfg['config']['settings']['rssfeedurl'], $this->cfg['config']['settings']['rssmaxitems'], $this->cfg['config']['settings']['rsstimeout']);

			if(!empty($feedpost))
			{
				$is_Split = $this->cfg['config']['settings']['split'];
				$is_last = count($feedpost);
				$half = ($is_Split ? ceil($is_last / 2) : $is_last);

				if(empty($feedheader['title']))
				{
					$feedheader['title'] = $this->cfg['config']['settings']['rssfeed_name'];
					$feedheader['link'] = $this->cfg['config']['settings']['rssfeed_link'];
					$feedheader['desc'] = $this->cfg['config']['settings']['rssfeed_desc'];
				}

				// Time To Life send ?
				if(!empty($this->cfg['config']['settings']['usettl']) && !empty($feedheader['ttl']))
					$this->TimeToLife = intval($feedheader['ttl']);

				// put the data on the content
				$this->cfg['content'] = '';
				if(!empty($this->cfg['config']['settings']['showhead']))
					$this->cfg['content'] = '
					<div class="tborder smalltext">
						'. (!empty($feedheader['link']) ? '<a href="'. $feedheader['link'] .'" target="_blank"><b>'. $feedheader['title'] .'</b></a>' : '<b>'. $feedheader['link']) .'</b>
						'. (!empty($feedheader['desc']) ? '<br />'. $feedheader['desc'] : '') .'
					</div>';

					$this->cfg['content'] .= '
					<table width="100%" cellpadding="0" cellspacing="0" border="0" style="table-layout:fixed;'. (!empty($this->cfg['config']['settings']['showhead']) ? ' padding-top:'. $context['PortaMx']['settings']['panels']['padding'] .'px;' : '') .'">
						<tr>
							<td'.($is_Split ? ' style="padding-'.$R_L.':'. $context['PortaMx']['settings']['panels']['padding'] .'px; width:50%;"' : '').' valign="top">';

				reset($feedpost);
				while(!empty($is_last))
				{
					$post = current($feedpost);
					if($is_Split && empty($half))
					{
						$this->cfg['content'] .= '
							</td>
							<td style="padding-'.$L_R.':'. $context['PortaMx']['settings']['panels']['padding'] .'px; width:50%;" valign="top">';
						reset($feedpost);
						next($feedpost);
						$post = current($feedpost);
					}
					$half--;
					$is_last--;
					$add_line = '';

					$this->cfg['content'] .= '
								<div class="catbg">
									<img src="'. $context['PMx_imageurl'] .'rssfeed.gif" alt="*" title="" />&nbsp;
									<span style="vertical-align:2px;">';
					if(!empty($post['tlink']) || !empty($post['slink']))
						$this->cfg['content'] .= '
										<a href="'. (!empty($post['tlink']) ? $post['tlink'] : $post['slink']) .'" target="_blank">'. $post['subject'] .'</a>';
					else
						$this->cfg['content'] .= '
										'. $post['subject'];
					$this->cfg['content'] .= '
									</span>
								</div>
								<div class="smalltext" style="padding-top:3px;">';

					if(!empty($post['poster']))
					{
						$add_line = '<br />
									';
						$this->cfg['content'] .= '
									'. $txt['pmx_rssreader_postby'];
						if(!empty($post['plink']))
							$this->cfg['content'] .= '<a href="'. $post['plink'] .'" target="_blank">'. $post['poster'] .'</a>';
						else
							$this->cfg['content'] .= $post['poster'];
					}

					if(!empty($post['date']))
					{
						$add_line = '<br />
									';
						if(empty($post['poster']))
							$this->cfg['content'] .= $txt['pmx_rssreader_postat'];
						else
							$this->cfg['content'] .= ', ';
						$this->cfg['content'] .= $post['date'];
					}

					if(!empty($post['board']) || !empty($post['category']))
						$this->cfg['content'] .= $add_line . (!empty($post['board']) ? $txt['pmx_rssreader_board'] . (!empty($post['blink']) ? '<a href="'. $post['blink'] .'" target="_blank">'. $post['board'] .'</a>' : $post['board']) : $txt['pmx_rssreader_category'] .$post['category']);

					$this->cfg['content'] .= '
								</div>
								'. (!empty($add_line) ? '<hr />' : '') .'
								<div style="padding-bottom:5px; overflow:hidden;">
									'. (!empty($this->cfg['config']['settings']['cont_encode']) && !empty($post['contenc']) ? $post['contenc'] : $post['message']) .'
								</div>
								<div class="smalltext" style="padding-bottom:'.(empty($is_last) || empty($half) ? '0' : '4'). 'px;">
									<a href="'. $post['slink'] .'" target="_blank">'. $txt['pmx_rssreader_readmore'] .'</a>
								</div>';

					next($feedpost);
					if($is_Split)
						next($feedpost);
				}
				$this->cfg['content'] .= '
							</td>
						</tr>
					</table>';
					$ret = true;
			}
      else
				$this->cfg['content'] = $txt['pmx_rssreader_error'];
		}
    return $ret;
	}
}
