<?php
/** 
* @file rss_reader_adm.php
* Admin Systemblock rss_reader
*
* @author PortaMx - Portal Management Extension
* @author Copyright 2008-2009 by PortaMx - http://portamx.com
* @Version: 0.957
* @Date: 11.03.2009
*/

if(!defined('PortaMx'))
	die('This file can\'t be run without PortaMx');

global $context, $txt;

/// Registerblock setup (description & icon)
$context['PortaMx']['RegisterBlocks']['rss_reader'] = array(
		'description' => $txt['pmx_rss_reader_description'],
		'blocktype' => $txt['pmx_sysblock'],
		'icon' => 'rss',
);

/**
* @class pmxc_rss_reader_adm
* Admin Systemblock rss_reader_adm
* @see rss_reader_adm.php
* @author Copyright by PortaMx - http://portamx.com
*/
class pmxc_rss_reader_adm extends PortaMxC_SystemAdminBlock
{
	/**
	* AdmBlock_init().
	* Setup caching and returns the language file name.
	*/
	function pmxc_AdmBlock_init()
	{
		$this->can_cached = 1;		// enable caching
		return 'rss_reader';			// language
	}

	/**
	* AdmBlock_settings().
	* Setup the config vars and output the block settings.
	* Returns the css classes they are used.
	*/
	function pmxc_AdmBlock_settings()
	{
		global $context, $txt;

		// define the settings options
		echo '
					<td valign="top" style="padding:4px;">
						<input type="hidden" name="config[langfile]" value="'. $this->cfg['config']['langfile'] .'" />
						<input type="hidden" name="config[settings]" value="" />';

		// define numeric vars to check
		echo '
						<input type="hidden" name="check_num_vars[]" value="[config][settings][rssmaxitems], \'\'" />
						<input type="hidden" name="check_num_vars[]" value="[config][settings][rsstimeout], \'5\'" />';

		// show the settings screen
		echo '
						<div class="titlebg adm_titlebar">'. $txt['pmx_rssreader_title'] .'</div>

						<div class="adm_input" style="height:40px;">
							<span class="adm_w90">'. $txt['pmx_rssreader_url'] .'
								<img class="info_toggle" onclick=\'Show_help("pmxRSSH01")\' src="'. $context['PMx_imageurl'] .'information.gif" alt="*" title="'. $txt['pmx_information_icon'] .'" />
							</span>
							<input class="adm_w90" style="margin-top:6px;" type="text" name="config[settings][rssfeedurl]" value="' .(!empty($this->cfg['config']['settings']['rssfeedurl']) ? $this->cfg['config']['settings']['rssfeedurl'] : ''). '" />
						</div>
						<div id="pmxRSSH01" class="info_frame" style="margin:2px 0px;">'. $txt['pmx_rssreader_urlhelp'] .'</div>
						<div class="adm_input" style="height:20px;">
							<span class="adm_w80">'. $txt['pmx_rssreader_timeout'] .'
								<img class="info_toggle" onclick=\'Show_help("pmxRSSH02")\' src="'. $context['PMx_imageurl'] .'information.gif" alt="*" title="'. $txt['pmx_information_icon'] .'" />
							</span>
							<div><input onkeyup="check_numeric(this);" size="2" type="text" name="config[settings][rsstimeout]" value="' .(!empty($this->cfg['config']['settings']['rsstimeout']) ? $this->cfg['config']['settings']['rsstimeout'] : '5'). '" /></div>
						</div>
						<div id="pmxRSSH02" class="info_frame" style="margin:2px 0px;">'. $txt['pmx_rssreader_timeouthelp'] .'</div>
						<div class="adm_check" style="height:20px;">
							<span class="adm_w80">'. $txt['pmx_rssreader_usettl'] .'
								<img class="info_toggle" onclick=\'Show_help("pmxRSSH03")\' src="'. $context['PMx_imageurl'] .'information.gif" alt="*" title="'. $txt['pmx_information_icon'] .'" />
							</span>
							<input type="hidden" name="config[settings][usettl]" value="0" />
							<div><input class="check" type="checkbox" name="config[settings][usettl]" value="1"' .(!empty($this->cfg['config']['settings']['usettl']) ? ' checked="checked"' : ''). ' /></div>
						</div>
						<div id="pmxRSSH03" class="info_frame" style="margin:2px 0px;">'. $txt['pmx_rssreader_usettlhelp'] .'</div>
						<div class="adm_input" style="height:20px;">
							<span class="adm_w80">'. $txt['pmx_rssreader_maxitems'] .'</span>
							<div><input onkeyup="check_numeric(this);" size="2" type="text" name="config[settings][rssmaxitems]" value="' .(!empty($this->cfg['config']['settings']['rssmaxitems']) ? $this->cfg['config']['settings']['rssmaxitems'] : ''). '" /></div>
						</div>
						<div class="adm_check" style="height:20px;">
							<span class="adm_w80">'. $txt['pmx_rssreader_cont_encode'] .'
								<img class="info_toggle" onclick=\'Show_help("pmxRSSH04")\' src="'. $context['PMx_imageurl'] .'information.gif" alt="*" title="'. $txt['pmx_information_icon'] .'" />
							</span>
							<input type="hidden" name="config[settings][cont_encode]" value="0" />
							<div><input class="check" type="checkbox" name="config[settings][cont_encode]" value="1"' .(!empty($this->cfg['config']['settings']['cont_encode']) ? ' checked="checked"' : ''). ' /></div>
						</div>
						<div id="pmxRSSH04" class="info_frame" style="margin:2px 0px;">'. $txt['pmx_rssreader_cont_encodehelp'] .'</div>
						<div class="adm_check" style="height:20px;">
							<span class="adm_w80">'. $txt['pmx_rssreader_split'] .'</span>
							<input type="hidden" name="config[settings][split]" value="0" />
							<div><input class="check" type="checkbox" name="config[settings][split]" value="1"' .(!empty($this->cfg['config']['settings']['split']) ? ' checked="checked"' : ''). ' /></div>
						</div>
						<div class="adm_check" style="height:20px;">
							<span class="adm_w80">'. $txt['pmx_rssreader_showhead'] .'
								<img class="info_toggle" onclick=\'Show_help("pmxRSSH05")\' src="'. $context['PMx_imageurl'] .'information.gif" alt="*" title="'. $txt['pmx_information_icon'] .'" />
							</span>
							<input type="hidden" name="config[settings][showhead]" value="0" />
							<div><input class="check" type="checkbox" name="config[settings][showhead]" value="1"' .(!empty($this->cfg['config']['settings']['showhead']) ? ' checked="checked"' : ''). ' /></div>
						</div>
						<div id="pmxRSSH05" class="info_frame" style="margin:2px 0px;">'. $txt['pmx_rssreader_help'] .'</div>

						<div class="adm_input" style="height:20px;">
							<span class="adm_w30">'. $txt['pxm_rssreader_name'] .'</span>
							<input class="adm_w60" type="text" name="config[settings][rssfeed_name]" value="' .(!empty($this->cfg['config']['settings']['rssfeed_name']) ? $this->cfg['config']['settings']['rssfeed_name'] : ''). '" />
						</div>
						<div class="adm_input" style="height:20px;">
							<span class="adm_w30">'. $txt['pxm_rssreader_link'] .'</span>
							<input class="adm_w60" type="text" name="config[settings][rssfeed_link]" value="' .(!empty($this->cfg['config']['settings']['rssfeed_link']) ? $this->cfg['config']['settings']['rssfeed_link'] : ''). '" />
						</div>
						<div class="adm_input" style="height:20px;">
							<span class="adm_w30">'. $txt['pxm_rssreader_desc'] .'</span>
							<input class="adm_w60" type="text" name="config[settings][rssfeed_desc]" value="' .(!empty($this->cfg['config']['settings']['rssfeed_desc']) ? $this->cfg['config']['settings']['rssfeed_desc'] : ''). '" />
						</div>
					</td>';

		// return the used classnames
		return $this->block_classdef;
	}
}
?>
