L<?php
/** 
* @file shoutbox.php
* Systemblock shoutbox
*
* @author PortaMx - Portal Management Extension
* @author Copyright 2008-2009 by PortaMx - http://portamx.com
* @Version: 0.957
* @Date: 11.03.2009
*/

if(!defined('PortaMx'))
	die('This file can\'t be run without PortaMx');

/**
* @class pmxc_shoutbox
* Systemblock shoutbox
* @see shoutbox.php
* @author Copyright by PortaMx - http://portamx.com
*/
class pmxc_shoutbox extends PortaMxC_SystemBlock
{
	var $smileys;			///< all smileys
	var $bb_code;			///< all bb codes
	var $bb_colors;		///< all bbc colors

	/**
	* InitContent.
	* Checked is a shout received ($_POST).
	*/
	function pmxc_InitContent()
	{
		global $scripturl, $context, $user_info, $user_profile, $smcFunc, $modSettings, $txt;

		if($this->visible)
		{
			$context['PortaMx']['shout_edit'] = -1;

			// setup bb codes
			$this->bb_code = array(
				array(
					'code' => 'b',
					'image' => $context['PMx_imageurl'] . 'shoutbbc_b.gif',
					'title' => $txt['pmx_shoutbbc_b'],
					),
				array(
					'code' => 'i',
					'image' => $context['PMx_imageurl'] . 'shoutbbc_i.gif',
					'title' => $txt['pmx_shoutbbc_i'],
					),
				array(
					'code' => 'u',
					'image' => $context['PMx_imageurl'] . 'shoutbbc_u.gif',
					'title' => $txt['pmx_shoutbbc_u'],
					),
				array(
					'code' => 'strike',
					'image' => $context['PMx_imageurl'] . 'shoutbbc_s.gif',
					'title' => $txt['pmx_shoutbbc_s'],
					),
				array(
					'code' => 'marquee',
					'image' => $context['PMx_imageurl'] . 'shoutbbc_m.gif',
					'title' => $txt['pmx_shoutbbc_m'],
					),
				array(
					'code' => 'sub',
					'image' => $context['PMx_imageurl'] . 'shoutbbc_sub.gif',
					'title' => $txt['pmx_shoutbbc_sub'],
					),
				array(
					'code' => 'sup',
					'image' => $context['PMx_imageurl'] . 'shoutbbc_sup.gif',
					'title' => $txt['pmx_shoutbbc_sup'],
					),
			);

			// setup bbc colors codes
			$this->bb_colors = array(
				$txt['pmx_shoutbbc_changecolor'] => $txt['pmx_shoutbbc_changecolor'],
				$txt['pmx_shoutbbc_colorBlack'] => '#000000',
				$txt['pmx_shoutbbc_colorRed'] => '#ff0000',
				$txt['pmx_shoutbbc_colorYellow'] => '#ffff00',
				$txt['pmx_shoutbbc_colorPink'] => '#ff00ff',
				$txt['pmx_shoutbbc_colorGreen'] => '#008000',
				$txt['pmx_shoutbbc_colorOrange'] => '#FFA500',
				$txt['pmx_shoutbbc_colorPurple'] => '#800080',
				$txt['pmx_shoutbbc_colorBlue'] => '#0000ff',
				$txt['pmx_shoutbbc_colorBeige'] => '#F5F5DC',
				$txt['pmx_shoutbbc_colorBrown'] => '#A52A2A',
				$txt['pmx_shoutbbc_colorTeal'] => '#008080',
				$txt['pmx_shoutbbc_colorNavy'] => '#000080',
				$txt['pmx_shoutbbc_colorMaroon'] => '#800000',
				$txt['pmx_shoutbbc_colorLimeGreen'] => '#00ff00',
				$txt['pmx_shoutbbc_colorWhite'] => '#ffffff',
			);

			// get the PortaMx smileys
			$smfiles = array();
			$this->smileys = array();
			if(is_dir($modSettings['smileys_dir'] . '/PortaMx/')) 
			{
				if($dh = opendir($modSettings['smileys_dir'] . '/PortaMx/')) 
				{
					while(($file = readdir($dh)) !== false)
					{
						if(!is_dir($file) && $file != 'none.gif' && $file != '..' && $file != '.')
						$smfiles[] = $file;
					}
				}
				closedir($dh);
				$request = $smcFunc['db_query']('', '
						SELECT code, filename, description
						FROM {db_prefix}smileys
						WHERE filename IN({array_string:files})
						ORDER BY smiley_order',
					array(
						'files' => $smfiles,
					)
				);
				while($row = $smcFunc['db_fetch_assoc']($request))
				{
					$this->smileys[] = array(
						'code' => addslashes($row['code']),
						'image' => $modSettings['smileys_url'] . '/PortaMx/'. $row['filename'],
						'title' => $row['description'],
					);
				}
				$smcFunc['db_free_result']($request);
			}
			unset($smfiles);

			// just reorder shouts ?
			if(!empty($this->cfg['config']['settings']['reorder']))
			{
				$shouts = unserialize($this->cfg['content']);
				$shouts = is_array($shouts) ? $shouts : array();
				$tmp = array_reverse($shouts);
				$this->cfg['content'] = serialize($tmp);
				unset($tmp);
				unset($this->cfg['config']['settings']['reorder']);
				$cfg = serialize($this->cfg['config']);

				// save new order
				$smcFunc['db_query']('', '
						UPDATE {db_prefix}portamx_blocks
						SET content = {string:content}, 
								config = {string:config}
						WHERE id = {int:id}',
					array(
						'id' => $this->cfg['id'],
						'content' => $this->cfg['content'],
						'config' => $cfg,
					)
				);
			}

			// shout send?
			if(isset($_POST['shout']))
			{
				$shoutcmd = PortaMx_makeSafe($_POST['shout']);
				unset($_POST['shout']);
				$update = false;

				// get the shouts
				$shouts = unserialize($this->cfg['content']);
				$shouts = is_array($shouts) ? $shouts : array();

				// delete a shout?
				if($shoutcmd == 'delete')
				{
					$id = PortaMx_makeSafe($_POST['shoutid']);
					if(isset($shouts[$id]))
					{
						unset($shouts[$id]);
						if(!empty($shouts))
						{
							foreach($shouts as $data)
								$new[] = $data;
							$shouts = $new;
						}
						$this->cfg['content'] = serialize($shouts);
						unset($new);
						$update = true;
					}
				}

				// update a shout?
				if($shoutcmd == 'update')
				{
					$id = PortaMx_makeSafe($_POST['shoutid']);
					if(isset($shouts[$id]))
					{
						// clean the input stream
						$post = PortaMx_makeSafeContent(str_replace(array("\r", "\n"), array('', ' '), $_POST['post']));
						$post = $this->ShortenBBCpost($post, intval($this->cfg['config']['settings']['maxlen']));
						if($this->BBCtoHTML($post) != '')
						{
							// convert html to char
							$post = $this->HTMLtoChar($post);
							$shouts[$id]['post'] = $this->ChartoHTML($post, true);
							$this->cfg['content'] = serialize($shouts);
							$update = true;
							$_SESSION['PortaMx']['shout_edit'] = $id;
						}
					}
				}

				// save a new shout ?
				if($shoutcmd == 'save')
				{
					// clean the input stream
					$post = PortaMx_makeSafeContent(str_replace(array("\r", "\n"), array('', ' '), $_POST['post']));
					$post = $this->ShortenBBCpost($post, intval($this->cfg['config']['settings']['maxlen']));
					if($this->BBCtoHTML($post) != '')
					{
						// get Memberdata (we need the group color)
						loadMemberData($user_info['id']);

						// get the shouts
						$shout = array(
							'uid' => $user_info['id'],
							'name' => $user_info['username'],
							'color' => $user_profile[$user_info['id']]['member_group_color'],
							'time' => forum_time(),
							'post' => $this->ChartoHTML($post, true),
						);

						if(!empty($this->cfg['config']['settings']['reverse']))
							array_push($shouts, $shout);
						else
							array_unshift($shouts, $shout);

						// max shouts reached?
						if(isset($this->cfg['config']['settings']['maxshouts']))
						{
							if(!empty($this->cfg['config']['settings']['reverse']))
							{
								while(count($shouts) > $this->cfg['config']['settings']['maxshouts'])
									array_shift($shouts);
							}
							else
								array_splice($shouts, $this->cfg['config']['settings']['maxshouts']);

							// resort
							foreach($shouts as $data)
								$new[] = $data;
							$shouts = $new;
							unset($new);
						}
						$this->cfg['content'] = serialize($shouts);
						$update = true;
					}
				}

				// need to save?
				if(!empty($update))
				{
					$smcFunc['db_query']('', '
							UPDATE {db_prefix}portamx_blocks
							SET content = {string:content}
							WHERE id = {int:id}',
						array(
							'id' => $this->cfg['id'],
							'content' => $this->cfg['content'],
						)
					);
				}

				// done, redirect
				$cmd = PortaMx_makeSafe($_SERVER['QUERY_STRING']);
				redirectexit($cmd);
			}
		}
		// return the visibility flag (true/false)
		return $this->visible;
	}

	/**
	* ShowContent
	*/
	function pmxc_ShowContent()
	{
		global $context, $scripturl, $user_info, $modSettings, $txt;

		// get the shouts
		$shouts = unserialize($this->cfg['content']);
		$shouts = is_array($shouts) ? $shouts : array();
		$inPad = -intval($this->cfg['config']['innerpad']);
	
		echo '
					<div style="margin:0px -'. intval($this->cfg['config']['innerpad']) .'px;">
						<div id="shoutframe" style="'. (isset($this->cfg['config']['settings']['maxheight']) ? 'max-height:'. $this->cfg['config']['settings']['maxheight'] .'px; overflow:auto; ' : '') .'padding:0px '. intval($this->cfg['config']['innerpad']) .'px;">';

		$haveshouts = false;
		foreach($shouts as $id => $data)
		{
			echo '
							<div id="shoutitem'. $id .'">
								<div class="tborder" style="border-style:dotted; padding:0 1px 2px 1px;">';

			if(AllowedTo('admin_forum') || ($user_info['id'] == $data['uid'] && !empty($this->cfg['config']['settings']['allowedit']) && $this->allowShout()))
			{
				$haveshouts = AllowedTo('admin_forum') || $user_info['id'] == $data['uid'] ? true : $haveshouts;
				echo '
									<img name="shoutimg" onclick="DeleteShout('. $id .');" style="cursor:pointer; margin-top:2px; display:none;" src="'. $context['PMx_imageurl'] .'shout_del.gif" align="right" alt="*" title="'. $txt['pmx_shoutbox_shoutdelete'] .'" />
									<img name="shoutimg" onclick="EditShout('. $id .', \''. addslashes($data['post']) .'\');" style="cursor:pointer; margin-top:2px; padding-right:4px; display:none;" src="'. $context['PMx_imageurl'] .'shout_edit.gif" align="right" alt="*" title="'. $txt['pmx_shoutbox_shoutedit'] .'" />';
			}

			// convert smileys and bb codes
			$data['post'] = $this->BBCtoHTML($data['post'], true);

			echo '
									<a href="'. $scripturl .'?action=profile;u='. $data['uid'] .'"><span'. (!empty($data['color']) ? ' style="color:'. $data['color'] .';"' : '') .'>'. $data['name'] .'</span></a>
								</div>
								<div style="padding:0px 1px 10px 1px;">
									'. timeformat($data['time']) .'<br />
									'. $data['post'] .'
								</div>
							</div>';
		}

		echo '
						</div>
					</div>';

		// have shout access?
		if($this->allowShout())
		{
			$canEdit = (AllowedTo('admin_forum') && $haveshouts) || ($haveshouts && !empty($this->cfg['config']['settings']['allowedit']));
			$Admimg[0] = $context['PMx_imageurl'] . ($canEdit ? 'shout_admon.gif' : 'empty.gif');
			$Admimg[1] = $context['PMx_imageurl'] . ($canEdit ? 'shout_admoff.gif' : 'empty.gif');
			echo '
					<form id="pmx_shoutform" action="'. $scripturl . $this->getQueryString() .'" method="post" style="padding-top:3px; margin:0 auto; text-align:center;">
						<input id="shout" type="hidden" name="shout" value="" />
						<input id="shoutid" type="hidden" name="shoutid" value="" />
						<textarea id="shoutcontent" style="width:98%; overflow:auto; height:6.2em;'. (!empty($this->cfg['config']['settings']['boxcollapse']) ? 'display:none;' : '') .'" name="post" cols="20" rows="4"></textarea>
						<img id="shoutbbon" style="cursor:pointer; margin-top:4px;'. (!empty($this->cfg['config']['settings']['boxcollapse']) ? 'display:none;' : '') .'" onclick="ShoutPopup();" src="'. $context['PMx_imageurl'] . 'type_bbc.gif" align="left" alt="*" title="'. $txt['pmx_shoutbox_bbc_code'] .'" />';

			if(!empty($this->cfg['config']['settings']['boxcollapse']))
				echo '
						<img id="shoutbboff" style="margin-top:4px;" src="'. $context['PMx_imageurl'] . 'empty.gif" align="left" alt="*" title="" />';

			echo '
						<img id="shout_toggle" style="'. ($canEdit ? 'cursor:pointer;' : '') .'margin-top:4px;"'. ($canEdit ? ' onclick="ShoutAdmin(\'check\');"' : '') .' src="'. $Admimg[0] .'" align="right" alt="*" title="'. $txt['pmx_shoutbox_toggle'] .'" />
						<input id="shout_key" onclick="SendShout();" type="button" name="button" value="'. $txt['pmx_shoutbox_button'] .'" title="'. (!empty($this->cfg['config']['settings']['boxcollapse']) ? $txt['pmx_shoutbox_button_title'] : $txt['pmx_shoutbox_send_title']) .'" style="margin-top:3px; width:100px;" />
					</form>';

			// smiley && bb codes popup
			echo '
					<div id="bbcodes" class="windowbg2" style="border:2px #909098 solid; line-height:25px; position:absolute; width:340px; height:84px; z-index:9999; display:none;">
						<div style="width:340px; height:52px;">';

			$half = ceil(count($this->smileys) / 2);
			foreach($this->smileys as $sm)
			{
				echo '
							<img onclick="InsertSmiley(\''. addslashes($sm['code']) .'\')" src="'. $sm['image'] .'" vspace="3" hspace="7" alt="*" title="'. $sm['title'] .'" align="left" style="cursor:pointer;" />';
				$half--;
				if($half == 0)
					echo '
						<br />';
			}
			echo '
						</div>
						<div style="border-top:1px #909098 solid; width:340px;">

							<select id="shout_color" size="1" name="" onchange="InsertBBColor(this); return false;" style="margin:6px 4px 0 0; float:right;">';

			foreach($this->bb_colors as $coltxt => $colname)
				echo '
								<option value="'. $colname .'"'. ($colname == $coltxt ? ' selected="selected"' : '') .'>'. $coltxt .'</option>';

			echo '
							</select>';

			foreach($this->bb_code as $sm)
				echo '
							<img onclick="InsertBBCode(\''. $sm['code'] .'\'); return false;" src="'. $sm['image'] .'" hspace="4" vspace="4" alt="*" title="'. $sm['title'] .'" align="left" style="cursor:pointer; background-color:#a0a8b0; border-width:2px; border-style:solid; border-color:#e0e0e0 #808890 #808890 #e0e0e0;" />';

			echo '
						</div>
					</div>';

			if(isset($_SESSION['PortaMx']['shout_edit']))
			{
				$context['PortaMx']['shout_edit'] = $_SESSION['PortaMx']['shout_edit'];
				unset($_SESSION['PortaMx']['shout_edit']);
			}
		}

		echo '
					<script type="text/javascript"><!-- // --><![CDATA[
						var MaxLoops = 50;
						var SB_StartPosition = 0;
						var SB_EndPosition = 0;
						var SB_Step = 0;

						// Shoutbox Scolling start checks if all smileys loaded
						function SB_ScollStart()
						{
							var SB_isLoad = 0;
							for(var i = 0; i < document.getElementsByTagName("img").length; i++)
							{
								var SB_smiley = document.getElementsByTagName("img")[i].src;
								if(SB_smiley.search(/'. substr(strrchr($modSettings['smileys_dir'], '/'), 1) .'\/PortaMx/) != -1)
								{
									if(!document.getElementsByTagName("img")[i].complete)
										SB_isLoad++;
								}
							}

							if(SB_isLoad != 0)
							{
								MaxLoops--;
								if(MaxLoops <= 0)
									window.clearInterval(SB_ScrollTimer);
							}
							else
							{
								window.clearInterval(SB_ScrollTimer);';

		if($context['PortaMx']['shout_edit'] >= 0)
			echo '
								var SB_Id = '. $context['PortaMx']['shout_edit'] .';
								var SB_y = 0;
								SB_Id++;
								while(document.getElementById("shoutitem"+SB_Id))
								{
									SB_y += document.getElementById("shoutitem"+SB_Id).offsetHeight;
									SB_Id++;
								}
								SB_EndPosition = (document.getElementById("shoutframe").scrollHeight - SB_y) - document.getElementById("shoutframe").offsetHeight;';

		elseif(!empty($this->cfg['config']['settings']['reverse']))
			echo '
								SB_EndPosition = document.getElementById("shoutframe").scrollHeight - document.getElementById("shoutframe").offsetHeight;';

		if(!empty($this->cfg['config']['settings']['scrollspeed']))
			echo '

								SB_Step = SB_EndPosition / (7.5 * '. $this->cfg['config']['settings']['scrollspeed'] .');';
		else
			echo '
								SB_Step = SB_EndPosition;';

		echo '
								SB_ScrollTimer = window.setInterval("SB_Srcoll_To()", 10);
							}
						}

						// Scroll the Shoutbox to endposition
						function SB_Srcoll_To()
						{
							if(SB_StartPosition < SB_EndPosition)
							{
								document.getElementById("shoutframe").scrollTop = SB_StartPosition;
								SB_StartPosition += SB_Step;
							}
							else
							{
								window.clearInterval(SB_ScrollTimer);
								document.getElementById("shoutframe").scrollTop = SB_EndPosition + '. ($context['PortaMx']['shout_edit'] < 0 ? 'document.getElementById("shoutframe").offsetHeight' : '0') .';
							}
						}';

		if($this->allowShout())
		{
			echo '
						var	inistate = "'. (isset($_COOKIE['pmx_shout']) ? $_COOKIE['pmx_shout'] : 'none') .'";
						ShoutAdmin(inistate);

						// insert smiley code
						function InsertSmiley(smcode)
						{
							ShoutInsert(smcode, "");
						}

						// insert BB code
						function InsertBBCode(smcode)
						{
							var aTag = "["+smcode+"]";
							var eTag = "[/"+smcode+"]";
							ShoutInsert(aTag, eTag);
						}

						// insert bb color code
						function InsertBBColor(elm)
						{
							var idx = elm.selectedIndex;
							elm.selectedIndex = 0;
							var color = elm.options[idx].value;
							var aTag = "[c="+color+"]";
							var eTag = "[/c]";
							ShoutInsert(aTag, eTag);
						}

						// insert a bbc element
						function ShoutInsert(aTag, eTag)
						{
							document.getElementById("shoutcontent").focus();
							var input = document.getElementById("shoutcontent");
							// IE
							if(typeof document.selection != "undefined") 
							{
								var range = document.selection.createRange();
								var insText = range.text;
								range.text = aTag + insText + eTag;
								// adjust cursor
								range = document.selection.createRange();
								if (insText.length == 0) 
									range.move("character", -eTag.length);
								else
									range.moveStart("character", aTag.length + insText.length + eTag.length);      
								range.select();
							}
							// Gecko
							else if(typeof input.selectionStart != "undefined")
							{
								var start = input.selectionStart;
								var end = input.selectionEnd;
								var insText = input.value.substring(start, end);
								input.value = input.value.substr(0, start) + aTag + insText + eTag + input.value.substr(end);
								// adjust cursor
								var pos;
								if (insText.length == 0)
									pos = start + aTag.length;
								else
									pos = start + aTag.length + insText.length + eTag.length;
								input.selectionStart = pos;
								input.selectionEnd = pos;
							}
						}

						// popup for bb code and smileys
						function ShoutPopup()
						{
							var element = document.getElementById("bbcodes");
							if(element.style.display == "none")
							{';

			if(!empty($this->cfg['config']['settings']['boxcollapse']))
				echo '
								if(document.getElementById("shoutcontent").style.display == "none")
									return;';

			echo '
								var pos = getPosition("shoutcontent");
								element.style.bottom = (pos.y - 8)+"px";
								element.style.top = (getPixVal(element.style.bottom) - getPixVal(element.style.height))+"px";';

			if($this->cfg['side'] == 'right')
				echo '
								element.style.left = (pos.x - ('. intval($context['PortaMx']['settings']['right_panel']['size']) .' + '. ($context['browser']['is_ie'] ? '27' : '31').'))+"px";
								element.style.right = (getPixVal(element.style.left) - getPixVal(element.style.width))+"px";';
			else
				echo '
								element.style.left = (pos.x)+"px";
								element.style.right = (getPixVal(document.getElementById("bbcodes").style.left) + getPixVal(document.getElementById("bbcodes").style.width))+"px";';
			echo'
								element.style.display = "";
							}
							else
								element.style.display = "none";

							document.getElementById("shoutcontent").focus();
						}

						// get a pixel value from styles
						function getPixVal(value)
						{
							var find = /(\d+)/;
							find.exec(value);
							return parseInt(RegExp.$1);
						}

						// get element position (x, y)
						function getPosition(elmID)
						{
							var tagname = "";
							var x = 0, y = 0;
							var elem = document.getElementById(elmID);

							while((typeof(elem) == "object")&&(typeof(elem.tagName) != "undefined"))
							{
								y += elem.offsetTop;
								x += elem.offsetLeft;
								tagname = elem.tagName.toUpperCase();
								if(tagname == "BODY")
									elem = 0;

								if(typeof(elem) == "object")
									if(typeof(elem.offsetParent) == "object")
										elem = elem.offsetParent;
						  }
							var position = new Object();
							position.x = x;
							position.y = y;
							return position;
						}

						// delete a shout
						function DeleteShout(Id)
						{
							if(confirm("'. $txt['pmx_shoutbox_shoutconfirm'] .'") == true)
							{
								document.getElementById("shout").value = "delete";
								document.getElementById("shoutid").value = Id;
								document.getElementById("pmx_shoutform").submit();
							}
						}

						// edit a shout
						function EditShout(Id, post)
						{
							document.getElementById("shoutcontent").style.display = "";
							document.getElementById("shout").value = "update";
							document.getElementById("shoutid").value = Id;
							document.getElementById("shoutcontent").value = post;
							document.getElementById("shoutcontent").focus();
							document.getElementById("shoutbbon").style.display = "";
							document.getElementById("shoutbboff").style.display = "none";
						}

						// send (submit) a shout
						function SendShout()
						{';

			if(!empty($this->cfg['config']['settings']['boxcollapse']))
				echo '
							if(document.getElementById("shoutcontent").style.display == "none")
							{
								document.getElementById("shout_key").title = "'. $txt['pmx_shoutbox_send_title'] .'";
								document.getElementById("shoutcontent").style.display = "";
								document.getElementById("shoutbbon").style.display = "";
								document.getElementById("shoutbboff").style.display = "none";
								document.getElementById("shoutcontent").focus();
							}
							else
							{
								document.getElementById("shout_key").title = "'. $txt['pmx_shoutbox_button_title'] .'";
								var cont = document.getElementById("shoutcontent").value;
								if(cont.match(/\S/g))
								{
									if(document.getElementById("shout").value == "")
										document.getElementById("shout").value = "save";
									document.getElementById("pmx_shoutform").submit();
								}
								else
								{
									document.getElementById("shoutcontent").value = "";
									document.getElementById("shoutcontent").style.display = "none";
									if(document.getElementById("bbcodes").style.display == "")
										ShoutPopup();
									document.getElementById("shoutbbon").style.display = "none";
									document.getElementById("shoutbboff").style.display = "";
								}
							}';
			else
				echo '
							var cont = document.getElementById("shoutcontent").value;
							if(cont.match(/\S/g))
							{
								if(document.getElementById("shout").value == "")
									document.getElementById("shout").value = "save";
								document.getElementById("pmx_shoutform").submit();
							}
							else
								document.getElementById("shoutcontent").value = "";';

			echo '
						}

						// toggle the edit mode
						function ShoutAdmin(state)
						{
							if(state == "check")
							{
								state = "none";
								if(document.getElementsByName("shoutimg")[0])
									state = document.getElementsByName("shoutimg")[0].style.display == "none" ? "" :"none";
							}

							if(document.getElementsByName("shoutimg")[0])
							{
								for(var i = 0; i < document.getElementsByName("shoutimg").length; i++)
									document.getElementsByName("shoutimg")[i].style.display = state;
							}
							else
								state = "none";

							if(state == "none")
							{
								document.getElementById("shout_toggle").src = "'. $Admimg[0] .'";
								document.getElementById("shoutcontent").value = "";
							}
							else
								document.getElementById("shout_toggle").src = "'. $Admimg[1] .'";

							document.cookie = "pmx_shout="+ state +"; path=/;";
						}';
		}
		echo '
						var SB_ScrollTimer = window.setInterval("SB_ScollStart()", 50);
					// ]]></script>';
	}

	/**
	* Check the shout access
	*/
	function allowShout()
	{
		global $user_info;

		$show = AllowedTo('admin_forum') ? true : false;
		if(isset($this->cfg['config']['settings']['shout_acs']))
		{
			foreach($user_info['groups'] as $g)
				$show = (in_array($g, $this->cfg['config']['settings']['shout_acs']) ? true : $show);
		}
		return $show;
	}

	/**
	* Get the querystrings
	*/
	function getQueryString()
	{
		$result = PortaMx_makeSafe($_SERVER['QUERY_STRING']);
		return empty($result) ? '' : '?'. $result;
	}

	// decode html chars
	function HTMLtoChar($value)
	{
		$value = str_replace(array('&#039;', '&quot;', '&lt;', '&gt;'), array("'", '\"', '<', '>'), $value);
		return  str_replace('&amp;', '&', $value);
	}

	/**
	* Encode html chars
	*/
	function ChartoHTML($value, $strip_spaces = false)
	{
		if($strip_spaces)
		{
			$value = trim($value);
			$i = 0;
			while($i < strlen($value))
			{
				if($value{$i} == ' ')
				{
					$l = 1;
					while($i + $l < strlen($value) && $value{$i + $l} == ' ')
						$l++;
					if($l > 1)
						$value = substr($value, 0, $i) . substr($value, ($i + $l) -1);
				}
				$i++;
			}
		}
		return htmlspecialchars($value);
	}

	/**
	* Get the color and inner content from color tag
	*/
	function getBBC_Color($value)
	{
		$i = 0;
		$tmp = strtolower($value);
		while($i <= strlen($tmp) && $tmp{$i} != ']')
			$i++;
		return array(trim(substr($tmp, 0, $i)), substr($value, $i +1));
	}

	/**
	* Shorten a shout entry
	*/
	function ShortenBBCpost($value, $maxlen)
	{
		$tmp = $value;
		// remove all bbc tags to get a clean stream
		while(preg_match_all('~\[(.*)(\]|\=)(.*)\[\/\\1\]~U', $tmp, $matches, PREG_PATTERN_ORDER) > 0)
		{
			if(!empty($matches[0]) && count($matches) == 4)
			{
				foreach($matches[0] as $id => $repl)
				{
					if($matches[2][$id] == ']')
						$tmp = str_replace($repl, $matches[3][$id], $tmp);
					else
					{
						$coltxt = $this->getBBC_Color($matches[3][$id]);
						$tmp = str_replace($repl, $coltxt[1], $tmp);
					}
				}
			}
		}

		// now check the length and shorten if longer then max
		if(strlen($tmp) > $maxlen)
		{
			while(strlen($tmp) > $maxlen)
			{
				$tmp = trim($tmp);
				while(strlen($tmp) > $maxlen && $value{strlen($value)-1} != ']')
				{
					$tmp = substr($tmp, 0, -1);
					$value = substr($value, 0, -1);
				}          

				if(strlen($tmp) > $maxlen)
				{
					if(preg_match_all('~\[(.*)(\]|\=)(.*)\[\/\\1\]~U', $value, $matches, PREG_PATTERN_ORDER))
					{
						if(!empty($matches[0]) && count($matches) == 4)
						{
							$id = count($matches[1]) -1;
							if(preg_match_all('~\[(.*)(\]|\=)(.*)\[\/\\1\]~U', $matches[3][$id], $match, PREG_PATTERN_ORDER))
							{       
								$id2 = count($match[1]) -1;
								$value = str_replace($match[0][$id2], '', $value);
								if($match[2][$id] == '=')
								{
									$coltxt = $this->getBBC_Color($match[3][$id]);
									$tmp = substr($tmp, 0, -strlen($coltxt[1]));
								}
								else
									$tmp = substr($tmp, 0, -strlen($match[3][$id2]));
							}
							else
							{    
								$value = str_replace($matches[0][$id], '', $value);
								if($matches[2][$id] == '=')
								{
									$coltxt = $coltxt = $this->getBBC_Color($matches[3][$id]);
									$tmp = substr($tmp, 0, -strlen($coltxt[1]));
								}
							}
						}
					}
				}
			}
		}
		return $value;
	}

	/**
	* Convert BB codes to html
	*/
	function BBCtoHTML($value, $addSmiley = false)
	{
		while(preg_match_all('~\[(.*)(\]|\=)(.*)\[\/\\1\]~U', $value, $matches, PREG_PATTERN_ORDER) > 0)
		{
			if(!empty($matches[0]) && count($matches) == 4)
			{
				if(preg_match_all('~\[(.*)(\]|\=)(.*)\[\/\\1\]~U', $matches[3][0], $match, PREG_PATTERN_ORDER) > 0)
				{
					$tmp = $this->BBCtoHTML($matches[3][0]);
					$value = str_replace($matches[3][0], $tmp, $value);
				}  
				else
				{
					foreach($matches[0] as $id => $repl)
					{
						if($matches[2][$id] == '=')
            {
              $coltxt = $this->getBBC_Color($matches[3][$id]);
							if($coltxt[1] != '')
								$value = str_replace($repl, '<span style="color:'. $coltxt[0] .';">'. $coltxt[1] .'</span>', $value);
							else
								$value = str_replace($repl, '', $value);
						}
						else
						{
							if(trim($matches[3][$id]) != '')
								$value = str_replace($repl, '<'. $matches[1][$id] .'>'. $matches[3][$id] .'</'. $matches[1][$id] .'>', $value);
							else
								$value = str_replace($repl, '', $value);
						}
	        }
				}
			}
		}
		if($addSmiley)
			$value = $this->convertSmileys($value);
		return $value;
	}

	/**
	* Convert the Smileys
	*/
	function convertSmileys($value)
	{
		foreach($this->smileys as $data)
		{
      $code = $this->ChartoHTML($data['code']);
			$smImage[$code] = '<img src="'. $data['image'] .'" title="'. $data['title'] .'" alt="*" />';
			$smReplace[$code] = preg_quote($code, '~');
		}
		$smPregSearch = '~(?<=[>:\?\.\s[\]()*\\\;]|^)('. implode('|', $smReplace) . ')(\s|$)+~e';
    return preg_replace($smPregSearch, 'isset($smReplace[\'$1\']) ? $smImage[\'$1\'] . \'$2\' : \'\'', $value);
	}
}
?>