<?php
/** 
* @file statistics.php
* Systemblock statistics
*
* @author PortaMx - Portal Management Extension
* @author Copyright 2008-2009 by PortaMx - http://portamx.com
* @Version: 0.957
* @Date: 11.03.2009
*/

if(!defined('PortaMx'))
	die('This file can\'t be run without PortaMx');

/**
* @class pmxc_statistics
* Systemblock statistics
* @see statistics.php
* @author Copyright by PortaMx - http://portamx.com
*/
class pmxc_statistics extends PortaMxC_SystemBlock
{
	/**
	* ShowContent
	* Prepare and output the content.
	*/
	function pmxc_ShowContent()
	{
		global $context, $scripturl, $settings, $modSettings, $txt;

		$is_adj = $context['browser']['is_ie'] || $context['browser']['is_opera'];
		$img = '<img src="'. $context['PMx_syscssurl'].'Images/bullet_blue.gif" alt="*" title="" />';
		$format = "$img<span>%1\$s:&nbsp;%2\$s</span>";
		$Rule = '';

		if(!empty($this->cfg['config']['settings']['stat_member']))
		{
			echo '
									<div'. (!empty($this->cfg['config']['visuals']['stats_text']) ? ' class="'. $this->cfg['config']['visuals']['stats_text'] .'"' : '') .'>
										<img src="'. $settings['theme_url'] .'/images/icons/members.gif" alt="" title="'. $txt['pmx_memberlist_icon'] .'" />
										<a href="'. $scripturl .'?action=mlist"><strong>'.  $txt['pmx_stat_member'] .'</strong></a>
									</div>
									<ul class="statistics">
										<li>'. sprintf($format, $txt['pmx_stat_totalmember'], (isset($modSettings['memberCount']) ? $modSettings['memberCount'] : $modSettings['totalMembers'])) .'</li>
										<li style="white-space:nowrap;">'. sprintf($format, $txt['pmx_stat_lastmember'], '<a href="'. $scripturl .'?action=profile;u='. $modSettings['latestMember'] .'"><strong>'. $modSettings['latestRealName'] .'</strong></a>') .'</li>
									</ul>';
			$Rule = '
									<hr />';
		}

		if(!empty($this->cfg['config']['settings']['stat_stats']))
		{
			echo $Rule .'
									<div'. (!empty($this->cfg['config']['visuals']['stats_text']) ? ' class="'. $this->cfg['config']['visuals']['stats_text'] .'"' : '') .'>
										<img src="'. $settings['theme_url'] .'/images/icons/info.gif" alt="" title="'. $txt['pmx_statistics_icon'] .'" />
										<a href="'. $scripturl .'?action=stats"><strong>'.  $txt['pmx_stat_stats'] .'</strong></a>
									</div>
									<ul class="statistics">
										<li>'. sprintf($format, $txt['pmx_stat_stats_post'], $modSettings['totalMessages']) .'</li>
										<li>'. sprintf($format, $txt['pmx_stat_stats_topic'], $modSettings['totalTopics']) .'</li>
										<li>'. sprintf($format, $txt['pmx_stat_stats_ol_today'], $modSettings['mostOnlineToday']) .'</li>
										<li>'. sprintf($format, $txt['pmx_stat_stats_ol_ever'], $modSettings['mostOnline']) .'</li>
									</ul>
									('. timeformat($modSettings['mostDate']) .')';
			$Rule = '
									<hr />';
		}

		if(!empty($this->cfg['config']['settings']['stat_users']) || !empty($this->cfg['config']['settings']['stat_olheight']))
		{
			$lines = 0.92 * (!empty($this->cfg['config']['settings']['stat_olheight']) ? $this->cfg['config']['settings']['stat_olheight'] : '5');
			$online = ssi_whosOnline('');

			if(!empty($this->cfg['config']['settings']['stat_users']))
			{
				echo $Rule .'
									<div'. (!empty($this->cfg['config']['visuals']['stats_text']) ? ' class="'. $this->cfg['config']['visuals']['stats_text'] .'"' : '') .'>
										<img src="'. $settings['theme_url'] .'/images/icons/online.gif" alt="" title="'. $txt['pmx_online_user_icon'] .'" />
										<a href="'. $scripturl .'?action=who"><strong>'.  $txt['pmx_stat_users'] .'</strong></a>
									</div>
									<ul class="statistics">
										<li>'. sprintf($format, $txt['pmx_stat_users_reg'], $online['num_users']) .'</li>
										<li>'. sprintf($format, $txt['pmx_stat_users_guest'], $online['guests']) .'</li>';

				if(!empty($this->cfg['config']['settings']['stat_spider']))
					echo '
										<li>'. sprintf($format, $txt['pmx_stat_users_spider'], $online['num_spiders']) .'</li>';

				echo '
										<li>'. sprintf($format, $txt['pmx_stat_users_total'], $online['total_users']) .'</li>
									</ul>';
				$Rule = '
									<hr />';
			}

			if(!empty($this->cfg['config']['settings']['stat_olheight']) && !empty($online['users']))
			{
				$img = '<img src="'. $context['PMx_syscssurl'].'Images/bullet_green.gif" alt="*" title="" />';
				echo $Rule .'
									<div class="onlinelist" style="max-height:'. $lines .'pc;">
									<ul class="statistics">';

				foreach($online['users'] as $user)
					echo '
											<li>'. $img .'<span>'.($user['hidden'] ? '<i>'. $user['link'] .'</i>' : $user['link']).'</span></li>';

				echo '
										</ul>
									</div>';
			}
		}
	}
}
?>