<?php
/** 
* @file statistics_adm.php
* Admin Systemblock statistics
*
* @author PortaMx - Portal Management Extension
* @author Copyright 2008-2009 by PortaMx - http://portamx.com
* @Version: 0.957
* @Date: 11.03.2009
*/

if(!defined('PortaMx'))
	die('This file can\'t be run without PortaMx');

global $context, $txt;

/// Registerblock setup (description & icon)
$context['PortaMx']['RegisterBlocks']['statistics'] = array(
		'description' => $txt['pmx_statistics_description'],
		'blocktype' => $txt['pmx_sysblock'],
		'icon' => 'system',
);

/**
* @class pmxc_statistics_adm
* Admin Systemblock statistics_adm
* @see statistics_adm.php
* @author Copyright by PortaMx - http://portamx.com
*/
class pmxc_statistics_adm extends PortaMxC_SystemAdminBlock
{
	/**
	* AdmBlock_init().
	* Setup caching and returns the language file name.
	*/
	function pmxc_AdmBlock_init()
	{
		$this->can_cached = 0;		// disable caching
		return 'statistics';			// language
	}

	/**
	* AdmBlock_settings().
	* Setup the config vars and output the block settings.
	* Returns the css classes they are used.
	*/
	function pmxc_AdmBlock_settings()
	{
		global $context, $txt;

		// define additional classnames and styles
		$used_classdef = $this->block_classdef;
		$used_classdef['stats_text'] = array(
			' '. $txt['pmx_default_none'] => '',
			' smalltext' => 'smalltext',
			' middletext' => 'middletext',
			'+normaltext' => 'normaltext',
			' largetext' => 'largetext',
		);

		// define the settings options
		echo '
					<td valign="top" style="padding:4px;">
						<input type="hidden" name="config[langfile]" value="'. $this->cfg['config']['langfile'] .'" />
						<input type="hidden" name="config[settings]" value="" />';

		// define numeric vars to check
		echo '
						<input type="hidden" name="check_num_vars[]" value="[config][settings][stat_olheight], 10" />';

		// show the settings screen
		echo '
						<div class="titlebg adm_titlebar">'. $txt['pmx_statistics_title'] .'</div>

						<div class="adm_check">
							<span class="adm_w80">'. $txt['pmx_admstat_member'] .'</span>
							<input type="hidden" name="config[settings][stat_member]" value="0" />
							<div><input class="check" type="checkbox" name="config[settings][stat_member]" value="1"' .(isset($this->cfg['config']['settings']['stat_member']) && !empty($this->cfg['config']['settings']['stat_member']) ? ' checked="checked"' : ''). ' /></div>
						</div>
						<div class="adm_check">
							<span class="adm_w80">'. $txt['pmx_admstat_stats'] .'</span>
							<input type="hidden" name="config[settings][stat_stats]" value="0" />
							<div><input class="check" type="checkbox" name="config[settings][stat_stats]" value="1"' .(isset($this->cfg['config']['settings']['stat_stats']) && !empty($this->cfg['config']['settings']['stat_stats']) ? ' checked="checked"' : ''). ' /></div>
						</div>
						<div class="adm_check">
							<span class="adm_w80">'. $txt['pmx_admstat_users'] .'</span>
							<input type="hidden" name="config[settings][stat_users]" value="0" />
							<div><input class="check" type="checkbox" name="config[settings][stat_users]" value="1"' .(isset($this->cfg['config']['settings']['stat_users']) && !empty($this->cfg['config']['settings']['stat_users']) ? ' checked="checked"' : ''). ' /></div>
						</div>
						<div class="adm_check">
							<span class="adm_w80">'. $txt['pmx_admstat_spider'] .'</span>
							<input type="hidden" name="config[settings][stat_spider]" value="0" />
							<div><input class="check" type="checkbox" name="config[settings][stat_spider]" value="1"' .(isset($this->cfg['config']['settings']['stat_spider']) && !empty($this->cfg['config']['settings']['stat_spider']) ? ' checked="checked"' : ''). ' /></div>
						</div>
						<div class="adm_input">
							<span class="adm_w80">'. $txt['pmx_admstat_olheight'] .'
								<img class="info_toggle" onclick=\'Show_help("pmxSTH01")\' src="'. $context['PMx_imageurl'] .'information.gif" alt="*" title="'. $txt['pmx_information_icon'] .'" />
							</span>
							<div><input onkeyup="check_numeric(this);" size="3" type="text" name="config[settings][stat_olheight]" value="' .(isset($this->cfg['config']['settings']['stat_olheight']) ? $this->cfg['config']['settings']['stat_olheight'] : '10'). '" /></div>
						</div>
						<div id="pmxSTH01" class="info_frame" style="margin-top:4px;">'. $txt['pmx_admstat_olheight_help'] .'</div>
					</td>';

		// return the used classnames
		return $used_classdef;
	}
}
?>