<?php
/** 
* @file theme_select.php
* Systemblock theme_select
*
* @author PortaMx - Portal Management Extension
* @author Copyright 2008-2009 by PortaMx - http://portamx.com
* @Version: 0.957
* @Date: 11.03.2009
*/

if(!defined('PortaMx'))
	die('This file can\'t be run without PortaMx');

/**
* @class pmxc_theme_select
* Systemblock theme_select
* @see theme_select.php
* @author Copyright by PortaMx - http://portamx.com
*/
class pmxc_theme_select extends PortaMxC_SystemBlock
{
	var $availthemes;			///< exist themes

	/**
	* InitContent.
	* Checks the cache status and create the content.
	*/
	function pmxc_InitContent()
	{
		global $context;

		if($this->visible)
		{
			$cstat = $this->pmxc_getCacheStatus();
			if(!empty($cstat) && $cstat < 0)		// refresh need?
			{
				$this->availthemes = PortaMx_getsmfThemes();	// get all themes
				$this->_ThemeContent();
				$this->pmxc_updateCache();
			}
			elseif(empty($cstat))
			{
				$this->availthemes = PortaMx_getsmfThemes();	// get all themes
				$this->_ThemeContent();
			}
		}
		// return the visibility flag (true/false)
		return $this->visible;
	}

	/**
	* ShowContent
	* Output the content and add necessary javascript
	*/
	function pmxc_ShowContent()
	{
		global $settings;
 
		// Write out the content
		echo $this->cfg['content'];

		$thid = (!empty($settings['theme_id']) ? $settings['theme_id'] : '1');
		echo '
	<script type="text/javascript"><!-- // --><![CDATA[
		document.getElementById("thumbnail").src = themeimages['. $thid .'];
		var elm = document.getElementById("pmx'.$this->cfg['id'].'themeselect");
		for(var idx = 0; idx < this.elm.length; idx++)
			elm.options[idx].selected = elm.options[idx].value == '. $thid .';
	// ]]></script>';
	}

	/**
	* _ThemeContent.
	* Prepare the content and save in $this->cfg['content'].
	*/
	function _ThemeContent()
	{
		global $context, $settings, $scripturl, $txt;

		$this->cfg['content'] = '';
		if(isset($this->cfg['config']['settings']['themes']))
		{
			$this->cfg['content'] .= '
									<select class="themsel" id="pmx'.$this->cfg['id'].'themeselect" name="" size="1" onchange="setThemeImage(this)">';

			foreach($this->availthemes as $thid => $data)
			{
				if(in_array($thid, $this->cfg['config']['settings']['themes']))
					$this->cfg['content'] .= '
										<option value="'. $thid .'"'. ($data['usertheme'] ? ' selected="selected"' : ($settings['theme_id'] == $thid ? ' selected="selected"' : '')) .'>'. $data['name'] .'</option>';
			}

			$this->cfg['content'] .= '
									</select>
									<div class="themthumb">
										<img class="tborder" id="thumbnail" src="" alt="*" title="'. $txt['pmx_theme_change'] .'" onclick="themeChange()" />
									</div>
	<script type="text/javascript"><!-- // --><![CDATA[
		var themeimages = new Array();';

			foreach($this->availthemes as $thid => $data)
			{
				if(in_array($thid, $this->cfg['config']['settings']['themes']))
					$this->cfg['content'] .= '
		themeimages['. $thid .'] = "'. $data['images_url'] .'/thumbnail.gif";';
			}

			$this->cfg['content'] .= '
		setThemeImage(document.getElementById("pmx'.$this->cfg['id'].'themeselect"));
		function setThemeImage(elm)
		{
			var idx = elm.selectedIndex;
			var thid = elm.options[idx].value;
			document.getElementById("thumbnail").src = themeimages[thid];
		}
		function themeChange()
		{
			var curpage = new String(window.location);
			curpage = curpage.search(/\?/) != -1 ? curpage.substring(curpage.search(/\?/)) : "";
      curpage = curpage.replace(/\;/g, "|");
			var elm = document.getElementById("pmx'.$this->cfg['id'].'themeselect");
			var thid = elm.options[elm.selectedIndex].value + ";pmxthemechg=" + escape(curpage);
			window.location.href = "'. $scripturl .'?theme=" + thid;
		}
// ]]></script>';
		}
	}
}
?>