<?php
/** 
* @file theme_select_adm.php
* Admin Systemblock theme_select
*
* @author PortaMx - Portal Management Extension
* @author Copyright 2008-2009 by PortaMx - http://portamx.com
* @Version: 0.957
* @Date: 11.03.2009
*/

if(!defined('PortaMx'))
	die('This file can\'t be run without PortaMx');

global $context, $txt;

/// Registerblock setup (description & icon)
$context['PortaMx']['RegisterBlocks']['theme_select'] = array(
		'description' => $txt['pmx_theme_select_description'],
		'blocktype' => $txt['pmx_sysblock'],
		'icon' => 'system',
);

/**
* @class pmxc_theme_select_adm
* Admin Systemblock theme_select_adm
* @see theme_select_adm.php
* @author Copyright by PortaMx - http://portamx.com
*/
class pmxc_theme_select_adm extends PortaMxC_SystemAdminBlock
{
	var $smf_themes;

	/**
	* AdmBlock_init().
	* get all available themes
	* Setup caching and returns the language file name.
	*/
	function pmxc_AdmBlock_init()
	{
		$this->smf_themes = PortaMx_getsmfThemes();		// get all themes
		$this->can_cached = 1;												// enable cache
		return 'theme_select';												// language
	}

	/**
	* AdmBlock_settings().
	* Setup the config vars and output the block settings.
	* Returns the css classes they are used.
	*/
	function pmxc_AdmBlock_settings()
	{
		global $context, $txt;

		$RtL = empty($context['right_to_left']) ? 'right' : 'left';

		// define the settings options
		echo '
					<td valign="top" style="padding:4px;">
						<input type="hidden" name="config[langfile]" value="'. $this->cfg['config']['langfile'] .'" />
						<input type="hidden" name="config[settings]" value="" />';

		// show the settings screen
		echo '
						<div class="titlebg adm_titlebar">'. $txt['pmx_themebox_title'] .'</div>

						<div class="adm_input">
							<span>'. $txt['pmx_select_themes'] .'</span>
							<img class="info_toggle" align="'. $RtL .'" style="padding:5px;"; onclick=\'Show_help("pmxUSH01")\' src="'. $context['PMx_imageurl'] .'information.gif" alt="*" title="'. $txt['pmx_information_icon'] .'" />
							<select class="adm_w90" name="config[settings][themes][]" size="7" multiple="multiple">';

			foreach($this->smf_themes as $thid => $data)
				echo '
								<option value="'. $thid .'"'. (!empty($this->cfg['config']['settings']['themes']) ? (in_array($thid, $this->cfg['config']['settings']['themes']) && $data['smfenabled'] ? ' selected="selected"' : '') : ($data['smfenabled'] ? ' selected="selected"' : '')) . ($data['smfenabled'] ? '' : ' disabled="disabled"'). '>'. $data['name'] .($data['smfenabled'] ? '' : ' [x]') .'</option>';

		echo '
							</select>
						</div>
						<div id="pmxUSH01" class="info_frame" style="margin-top:5px;">'. $txt['pmx_themes_hint'] .'</div>
					</td>';

		// return the default classnames
		return $this->block_classdef;
	}
}
?>