<?php
/** 
* @file user_login.php
* Systemblock user_login
*
* @author PortaMx - Portal Management Extension
* @author Copyright 2008-2009 by PortaMx - http://portamx.com
* @Version: 0.957
* @Date: 11.03.2009
*/

if(!defined('PortaMx'))
	die('This file can\'t be run without PortaMx');

/**
* @class pmxc_user_login
* Systemblock user_login
* @see user_login.php
* @author Copyright by PortaMx - http://portamx.com
*/
class pmxc_user_login extends PortaMxC_SystemBlock
{
	/**
	* ShowContent
	* Output the content.
	*/
	function pmxc_ShowContent()
	{
		global $context, $scripturl, $modSettings, $txt;

		$is_adj = $context['browser']['is_ie'] || $context['browser']['is_opera'];

		// avatar
		if(!empty($context['user']['avatar']) && isset($this->cfg['config']['settings']['show_avatar']) && $this->cfg['config']['settings']['show_avatar'] == 1)
			echo '
									<div style="padding-bottom:4px;">
										<a href="'. $scripturl .'?action=profile;u='. $context['user']['id'] .'">'. $context['user']['avatar']['image'] .'</a>
									</div>';

		// User logged in?
		if($context['user']['is_logged'])
		{
			echo '
									<span' .(isset($this->cfg['config']['visuals']['hellotext']) ? ' class="'. $this->cfg['config']['visuals']['hellotext'] .'"' : ''). '>'.
										(empty($context['right_to_left']) 
										? $txt['pmx_hello'] .' <a href="'. $scripturl .'?action=profile;u='. $context['user']['id'] .'"><b>'. $context['user']['name'] .'</b></a>'
										: '<a href="'. $scripturl .'?action=profile;u='. $context['user']['id'] .'"><b>'. $context['user']['name'] .'</b></a> '. $txt['pmx_hello']).'
									</span>';

			$img = '<img src="'. $context['PMx_syscssurl'].'Images/bullet_blue.gif" alt="*" title="" />';
			$img1 = '<img src="'. $context['PMx_syscssurl'].'Images/bullet_red.gif" alt="*" title="" />';
			echo '
									<ul class="userlogin">';

			// show pm?
			if (isset($this->cfg['config']['settings']['show_pm']) && $this->cfg['config']['settings']['show_pm'] == 1 && $context['allow_pm'])
				echo '
										<li>'.($context['user']['unread_messages'] > 0 ? $img1 : $img).'<span><a href="'. $scripturl .'?action=pm">'. $txt['pmx_pm'] .($context['user']['unread_messages'] > 0 ? ': '.$context['user']['unread_messages'].' <img src="'. $context['PMx_imageurl'].'newpm.gif" alt="*" title="'. $context['user']['unread_messages'] .'" />' : '').'</a></span></li>';

			// Are there any members waiting for approval?
			if (isset($this->cfg['config']['settings']['show_unapprove']) && $this->cfg['config']['settings']['show_unapprove'] == 1 && !empty($context['unapproved_members']))
				echo '
										<li>'.$img1.'<span><a href="'. $scripturl .'?action=admin;area=viewmembers;sa=browse;type=approve">'. $txt['pmx_unapproved_members'] .' <b>'. $context['unapproved_members']  .'</b></a></span></li>';

			// show post?
			if(isset($this->cfg['config']['settings']['show_posts']) && $this->cfg['config']['settings']['show_posts'] == 1)
			{
				echo '
										<li>'.$img.'<span><a href="'. $scripturl .'?action=unread">'. $txt['pmx_unread'] .'</a></span></li>
										<li>'.$img.'<span><a href="'. $scripturl .'?action=unreadreplies">'. $txt['pmx_replies'] .'</a></span></li>
										<li>'.$img.'<span><a href="'. $scripturl .'?action=profile;area=showposts;u='. $context['user']['id'] .'">'. $txt['pmx_showownposts'] .'</a></span></li>';
			}
			echo '
									</ul>';
			// Is the forum in maintenance mode?
			if($context['in_maintenance'] && $context['user']['is_admin'])
				echo '
									<b>'. $txt['pmx_maintenace'] .'</b><br />';

			// Show the total time logged in?
			if(!empty($context['user']['total_time_logged_in']) && isset($this->cfg['config']['settings']['show_logtime']) && $this->cfg['config']['settings']['show_logtime'] == 1)
			{
				$totm = $context['user']['total_time_logged_in'];
				if(empty($context['right_to_left']))
				{
					$form = '%s: %s%s %s%s %s%s';
					echo sprintf($form, $txt['pmx_loggedintime'], $totm['days'], $txt['pmx_Ldays'], $totm['hours'], $txt['pmx_Lhours'], $totm['minutes'], $txt['pmx_Lminutes']);
				}
				else
				{
					$form ='<br />%s%s %s%s %s%s :%s';
					echo sprintf($form, $txt['pmx_Ldays'], $totm['days'], $txt['pmx_Lhours'], $totm['hours'], $txt['pmx_Lminutes'], $totm['minutes'], $txt['pmx_loggedintime']);
				}
			}

			// show current time?
			if(isset($this->cfg['config']['settings']['show_time']) && $this->cfg['config']['settings']['show_time'] == 1)
			{
				if(isset($this->cfg['config']['settings']['show_realtime']) && $this->cfg['config']['settings']['show_realtime'] == 1)
					echo '
									<br /><span id="ulClock"></span>
									<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[
									function ulClock() {
										var ulnow = new Date();
										ulnow.setHours(ulnow.getHours() - (ulnow.getTimezoneOffset() / 60));
										var ulcurtime = ulnow.toGMTString();
										document.getElementById("ulClock").innerHTML = ulcurtime.substring(0, ulcurtime.lastIndexOf(" "));
										setTimeout("ulClock()",1000);
									}
									ulClock();
									// ]]></script>';
				else
					echo '
									<br />'. $context['current_time'];
			}

			// show logout button?
			if(isset($this->cfg['config']['settings']['show_logout']) && $this->cfg['config']['settings']['show_logout'] == 1)
				echo '
									<br />
									<div style="text-align:center;margin-top:5px;">
										<input type="button" value="'. $txt['logout'] .'" onclick="DoLogout()" />
									</div>
									<script type="text/javascript"><!-- // --><![CDATA[
										function DoLogout()
										{
											window.location = "'. $scripturl .'?action=logout;'. $context['session_var'] .'='. $context['session_id'] .'";
										}
									// ]]></script>';
		}

		// Otherwise they're a guest, ask them to register or login.
		else
		{
			$L_R = empty($context['right_to_left']) ? 'left' : 'right';
			$R_L = empty($context['right_to_left']) ? 'right' : 'left';
			echo '
									<span' .(isset($this->cfg['config']['visuals']['hellotext']) ? ' class="'. $this->cfg['config']['visuals']['hellotext'] .'"' : ''). '>'. sprintf($txt['welcome_guest'], $txt['guest_title']) .'</span><br />'.
									$context['current_time'];
			if(isset($this->cfg['config']['settings']['show_login']) && $this->cfg['config']['settings']['show_login'] == 1)
			{
				echo '
									<div>
										<form action="'. $scripturl .'?action=login2" method="post">
											<input type="text" name="user" style="width:42%;float:'. $L_R .';margin-bottom:3px;" /> 
											<input type="password" name="passwrd" style="width:42%;float:'. $R_L .';margin-bottom:3px;margin-'. $R_L .':4px;" />';

				if(!empty($modSettings['enableOpenID']))
					echo '
											<input type="text" name="openid_url" id="pmx'.$this->cfg['id'].'_openid_url" class="openid_login" style="width:84%;margin-bottom:3px;" />';

				echo '
											<select name="cookielength" style="width:45%;float:'. $L_R .';">
												<option value="60">'. $txt['one_hour'] .'</option>
												<option value="1440">'. $txt['one_day'] .'</option>
												<option value="10080">'. $txt['one_week'] .'</option>
												<option value="302400">'. $txt['one_month'] .'</option>
												<option value="-1" selected="selected">' . $txt['forever'] .'</option>
											</select>
											<input style="float:'.$R_L.';margin-'.$R_L.':4px;" type="submit" value="'. $txt['login'] .'" />
											<br style="clear:both;" />'. $txt['quick_login_dec'] .'
										</form>
									</div>';
			}
		}
	}
}
?>