<?php
/** 
* @file user_login_adm.php
* Admin Systemblock user_login
*
* @author PortaMx - Portal Management Extension
* @author Copyright 2008-2009 by PortaMx - http://portamx.com
* @Version: 0.957
* @Date: 11.03.2009
*/

if(!defined('PortaMx'))
	die('This file can\'t be run without PortaMx');

global $context, $txt;

/// Registerblock setup (description & icon)
$context['PortaMx']['RegisterBlocks']['user_login'] = array(
		'description' => $txt['pmx_user_login_description'],
		'blocktype' => $txt['pmx_sysblock'],
		'icon' => 'system',
);

/**
* @class pmxc_user_login_adm
* Admin Systemblock user_login_adm
* @see user_login_adm.php
* @author Copyright by PortaMx - http://portamx.com
*/
class pmxc_user_login_adm extends PortaMxC_SystemAdminBlock
{
	/**
	* AdmBlock_init().
	* Setup caching and returns the language file name.
	*/
	function pmxc_AdmBlock_init()
	{
		$this->can_cached = 0;		// disable caching
		return 'user_login';			// language
	}

	/**
	* AdmBlock_settings().
	* Setup the config vars and output the block settings.
	* Returns the css classes they are used.
	*/
	function pmxc_AdmBlock_settings()
	{
		global $context, $txt;

		// define additional classnames and styles
		$used_classdef = $this->block_classdef;
		$used_classdef['hellotext'] = array(
			' '. $txt['pmx_default_none'] => '',
			' smalltext' => 'smalltext',
			' middletext' => 'middletext',
			'+normaltext' => 'normaltext',
			' largetext' => 'largetext',
		);

		// define the settings options
		echo '
					<td valign="top" style="padding:4px;">
						<input type="hidden" name="config[langfile]" value="'. $this->cfg['config']['langfile'] .'" />
						<input type="hidden" name="config[settings]" value="" />';

		// show the settings screen
		echo '
						<div class="titlebg adm_titlebar">'. $txt['pmx_userbox_title'] .'</div>

						<div class="adm_check">
							<span class="adm_w80">'. $txt['show_avatar'] .'</span>
							<div><input class="check" type="checkbox" name="config[settings][show_avatar]" value="1"' .(isset($this->cfg['config']['settings']['show_avatar']) && $this->cfg['config']['settings']['show_avatar'] == 1 ? ' checked="checked"' : ''). ' /></div>
						</div>

						<div class="adm_check">
							<span class="adm_w80">'. $txt['show_pm'] .'</span>
							<div><input class="check" type="checkbox" name="config[settings][show_pm]" value="1"' .(isset($this->cfg['config']['settings']['show_pm']) && $this->cfg['config']['settings']['show_pm'] == 1 ? ' checked="checked"' : ''). ' /></div>
						</div>

						<div class="adm_check">
							<span class="adm_w80">'. $txt['show_posts'] .'</span>
							<div><input class="check" type="checkbox" name="config[settings][show_posts]" value="1"' .(isset($this->cfg['config']['settings']['show_posts']) && $this->cfg['config']['settings']['show_posts'] == 1 ? ' checked="checked"' : ''). ' /></div>
						</div>

						<div class="adm_check">
							<span class="adm_w80">'. $txt['show_logtime'] .'</span>
							<div><input class="check" type="checkbox" name="config[settings][show_logtime]" value="1"' .(isset($this->cfg['config']['settings']['show_logtime']) && $this->cfg['config']['settings']['show_logtime'] == 1 ? ' checked="checked"' : ''). ' /></div>
						</div>

						<div class="adm_check">
							<span class="adm_w80">'. $txt['show_time'] .'</span>
							<div><input class="check" type="checkbox" name="config[settings][show_time]" value="1"' .(isset($this->cfg['config']['settings']['show_time']) && $this->cfg['config']['settings']['show_time'] == 1 ? ' checked="checked"' : ''). ' /></div>
						</div>

            <div class="adm_check">
              <span class="adm_w80">'. $txt['show_realtime'] .'</span>
              <div><input class="check" type="checkbox" name="config[settings][show_realtime]" value="1"' .(isset($this->cfg['config']['settings']['show_realtime']) && $this->cfg['config']['settings']['show_realtime'] == 1 ? ' checked="checked"' : ''). ' /></div>
            </div>
            
						<div class="adm_check">
							<span class="adm_w80">'. $txt['show_unapprove'] .'</span>
							<div><input class="check" type="checkbox" name="config[settings][show_unapprove]" value="1"' .(isset($this->cfg['config']['settings']['show_unapprove']) && $this->cfg['config']['settings']['show_unapprove'] == 1 ? ' checked="checked"' : ''). ' /></div>
						</div>

						<div class="adm_check">
							<span class="adm_w80">'. $txt['show_login'] .'</span>
							<div><input class="check" type="checkbox" name="config[settings][show_login]" value="1"' .(isset($this->cfg['config']['settings']['show_login']) && $this->cfg['config']['settings']['show_login'] == 1 ? ' checked="checked"' : ''). ' /></div>
						</div>

						<div class="adm_check">
							<span class="adm_w80">'. $txt['show_logout'] .'</span>
							<div><input class="check" type="checkbox" name="config[settings][show_logout]" value="1"' .(isset($this->cfg['config']['settings']['show_logout']) && $this->cfg['config']['settings']['show_logout'] == 1 ? ' checked="checked"' : ''). ' /></div>
						</div>
					</td>';

		// return the classnames to use
		return $used_classdef;
	}
}
?>