<?php
/** 
* @file PortaMx.php
* The main programm for PortaMx.
*
* @author PortaMx - Portal Management Extension
* @author Copyright 2008-2009 by PortaMx - http://portamx.com
* @Version: 0.957
* @Date: 11.03.2009
*/

if(!defined('SMF'))
	die('Hacking attempt...');

/**
* Init all variables and load the settings from the database.
* Check the requests and prepare the templates to load.
*/
function PortaMx($CalledFrom = '')
{
	global $smcFunc, $context, $settings, $db_character_set, $modSettings, $sourcedir, $boarddir, $txt, $mbname, $scripturl, $user_info, $language;

	if(defined('PortaMx'))
		return;

	define('PortaMx', 1);
	// setup dirs
	$context['PMx_sourcedir'] = $sourcedir .'/PortaMx/';
	$context['PMx_classdir'] = $sourcedir .'/PortaMx/Class/';
	$context['PMx_sysclassdir'] = $sourcedir .'/PortaMx/Class/System/';
	$context['PMx_templatedir'] = 'PortaMx/';
	$context['PMx_blockslangdir'] = 'PortaMx/Blocks/';
	$context['PMx_syscssdir'] = $settings['default_theme_dir'] .'/PortaMx/SysCss/';
	$context['PMx_blockscssdir'] = $settings['default_theme_dir'] .'/PortaMx/BlockCss/';
	$context['PMx_languagedir'] = $settings['default_theme_dir'] .'/languages/PortaMx/';
	// .. urls
	$context['PMx_imageurl'] = $settings['default_theme_url'] .'/PortaMx/Images/';
	$context['PMx_scripturl'] = $settings['default_theme_url'] .'/PortaMx/Scripts/';
	$context['PMx_syscssurl'] = $settings['default_theme_url'] .'/PortaMx/SysCss/';
	$context['PMx_blockscssurl'] = $settings['default_theme_url'] .'/PortaMx/BlockCss/';
	// user icons link/path
	$context['PMx_Iconsurl'] = $settings['default_theme_url'] .'/PortaMx/TitleIcons/';
	$context['PMx_Iconsdir'] = $settings['default_theme_dir'] .'/PortaMx/TitleIcons/';

	// check if utf8 charset used
	$context['PortaMx']['uses_utf8'] = ((isset($modSettings['global_character_set']) && $modSettings['global_character_set'] == 'UTF-8') || (isset($db_character_set) && $db_character_set == 'utf8'));

	// load require file
	require_once($context['PMx_sourcedir'] .'LoadData.php');
	require_once($context['PMx_sysclassdir']. 'PortaMx_BlocksClass.php');
	// load the SSI.php
	require_once($boarddir .'/SSI.php');

	// get all settings
	$context['pmx_head'] = substr(file_get_contents(__FILE__), 0, 256);
	$context['PortaMx']['settings'] = PortaMx_getSettings();

	// load common language
	loadLanguage($context['PMx_templatedir'] .'PortaMx');

	// setup all block sides
	$context['PortaMx']['block_sides'] = array_keys($txt['pmx_block_sides']);

	// setup panel collapse, xbars and xbarkeys
	foreach($context['PortaMx']['block_sides'] as $side)
	{
		if($side != 'front')
		{
			$context['PortaMx']['xbar_'.$side] = isset($context['PortaMx']['settings']['xbars']) && in_array($side, array_values($context['PortaMx']['settings']['xbars']));
			$context['PortaMx']['xbarkeys'] = isset($context['PortaMx']['settings']['xbarkeys']) && !empty($context['PortaMx']['settings']['xbarkeys']);
			$context['PortaMx']['collapse'][$side] = empty($context['PortaMx']['settings'][$side.'_panel']['collapse']) && ($context['PortaMx']['xbar_'.$side] || $context['PortaMx']['xbarkeys']);
		}
	}

	// setup quick edit for admin and pmx moderator
	$context['PortaMx']['quickedit'] = !empty($context['PortaMx']['settings']['manager']['qedit']) && (allowedTo('manage_portamx') || allowedTo('admin_forum'));

	// exit on follow actions or wireless
	if(WIRELESS || $CalledFrom == 'SSI' || isset($_REQUEST['xml']) || isset($_REQUEST['action']) && in_array($_REQUEST['action'], array('jsoption', '.xml', 'xmlhttp')))
		return;

	// exit on external login with redirect
	if(isset($_REQUEST['action']) && $_REQUEST['action'] == 'login' && isset($_SESSION['old_url']) && preg_match('~(board|topic)[=,]~', $_SESSION['old_url']) != 0)
		return;

	// on Admin or Moderate load admin language and admin blocks class
	if(isset($_REQUEST['action']) && ($_REQUEST['action'] == 'admin' || $_REQUEST['action'] == 'moderate'))
	{
		// load the admin javascrip
		$context['html_headers'] .= '
			<script language="JavaScript" type="text/javascript" src="'. $context['PMx_scripturl'] .'AdminBlocks.js"></script>
			<script language="JavaScript" type="text/javascript" src="'. $context['PMx_scripturl'] .'AdminPopups.js"></script>';

		// admin languages
		loadLanguage($context['PMx_templatedir'] .'Admin');
		$file = $context['PMx_languagedir'] . 'UserBlocks.'. (isset($user_info['language']) ? $user_info['language'] : $language) . '.php';
		if(file_exists($file))
			loadLanguage($context['PMx_templatedir'] .'UserBlocks');

		// on blocksmanager load the the admin classes
		if(isset($_REQUEST['area']) && $_REQUEST['area'] == 'pmx_blocks')
		{
			require_once($context['PMx_sysclassdir']. 'PortaMx_AdminBlocksClass.php');
			PortaMx_loadClassfiles($context['PMx_classdir']);
		}
	}

	// check if a permanent theme change requested
	if(isset($_REQUEST['theme']) && isset($_REQUEST['pmxthemechg']))
		PortaMx_ChangeTheme($_REQUEST['theme'], $_REQUEST['pmxthemechg']);

	// check if a language change requested
	if(isset($_REQUEST['language']) && isset($_REQUEST['pmxlangchg']))
		PortaMx_ChangeRedirect($_REQUEST['pmxlangchg']);

	// check Page request
	$PageReq = '';
  if(preg_match_all('/([\w\.\-\_]+)/', PortaMx_makeSafe($_SERVER['QUERY_STRING']), $matches) == 1)
	{
		$ignoreReq = isset($context['PortaMx']['settings']['norequest']) ? explode(',', str_replace(' ', '', $context['PortaMx']['settings']['norequest'])) : array();
		if(!in_array($matches[0][0], $ignoreReq))
		{
			$PageReq = $matches[0][0];
			unset($_REQUEST[str_replace('.', '_', $matches[0][0])]);
			unset($_GET[str_replace('.', '_', $matches[0][0])]);
			$_REQUEST['action'] = '@'. $PageReq;
		}
	}

	// Admin panel hidding ?
	if($user_info['is_admin'] && !empty($_REQUEST['paneloff']))
	{
		if($_REQUEST['paneloff'] == 'none' && isset($_SESSION['pxm_paneloff']))
			unset($_SESSION['pxm_paneloff']);
		elseif($_REQUEST['paneloff'] == 'all')
			$_SESSION['pxm_paneloff'] = $context['PortaMx']['block_sides'];
		elseif(in_array($_REQUEST['paneloff'], $context['PortaMx']['block_sides']))
			$_SESSION['pxm_paneloff'] = array($_REQUEST['paneloff']);
	}

	// check all the actions and mutch more...
  if(empty($_REQUEST['action']) && empty($_REQUEST['board']) && empty($_REQUEST['topic']) && empty($_REQUEST['project']) && empty($_REQUEST['issue']))
	{
		// if a redirect request, exit
		$requrl = (strpos($_SERVER['REQUEST_URL'], substr($scripturl, 0, strrpos($scripturl, '/'))) === false ? $_SERVER['REQUEST_URL'] : $scripturl);
		if(substr($requrl, 0, strrpos($requrl, '/')) != substr($scripturl, 0, strrpos($scripturl, '/')))
			return;

		// use the frontpage ?
		if($context['PortaMx']['settings']['frontpage'] != 'none')
		{
			$context['page_title'] = $context['forum_name'];

			// build the linktree
			if(isset($context['PortaMx']['settings']['panels']['hidelinktree']) && !empty($context['PortaMx']['settings']['panels']['hidelinktree'])
				|| isset($context['PortaMx']['settings']['panels']['hidelinktreefront']) && !empty($context['PortaMx']['settings']['panels']['hidelinktreefront']))
				$context['linktree'] = array(array('url' => $scripturl, 'name' => ''));
			else
				$context['linktree'] = array(array('url' => $scripturl, 'name' => $mbname));

			// get all block on active panels they can view
			$context['PortaMx']['viewblocks'] = getPanelsToShow('frontpage', false);

			// setup headers
			PortaMx_headers();

			// frontpage block exist ?
			if(!empty($context['PortaMx']['show_frontpanel']))
			{
				if($context['PortaMx']['settings']['frontpage'] == 'fullsize')
				{
					loadTemplate($context['PMx_templatedir'] .'Frontpage');
					$context['template_layers'] = array('fronthtml', 'portamx');
				}
				elseif($context['PortaMx']['settings']['frontpage'] == 'centered')
				{
					loadTemplate($context['PMx_templatedir'] .'Mainindex');
					$context['template_layers'][] = 'portamx';
					loadTemplate($context['PMx_templatedir'] .'PortaMx');
				}
			}
			else	// no frontpage block -> boardindex
				redirectexit('action=forum');
		}
		else		// go directly to boardindex
			redirectexit('action=forum');
	}
	else
	{
		// get the action
		$action = (isset($_REQUEST['action']) ? $_REQUEST['action'] : (isset($_REQUEST['board']) ? 'boards' : (isset($_REQUEST['topic']) ? 'topics' : (isset($_REQUEST['project']) || isset($_REQUEST['issue']) ? 'project' : ''))));

		// build the linktree
		if(isset($context['PortaMx']['settings']['panels']['hidelinktree']) && !empty($context['PortaMx']['settings']['panels']['hidelinktree']))
			$context['linktree'] = array(array('url' => $scripturl, 'name' => ''));
		else
		{
			if(empty($context['linktree']))
				$context['linktree'] = array(array('url' => $scripturl, 'name' => $mbname));
			$pmxhome = array_shift($context['linktree']);

			if(!empty($PageReq))
				$pmxforum = array('url' => $scripturl . '?'. $PageReq, 'name' => ucwords(str_replace('-', ' ', $PageReq)));
			else
				$pmxforum = array('url' => $scripturl . '?action=forum', 'name' => $txt['forum']);

			if($context['PortaMx']['settings']['frontpage'] == 'none')
				$context['linktree'] = array_merge(array($pmxhome), $context['linktree']);
			else
				$context['linktree'] = array_merge(array($pmxhome), array($pmxforum), $context['linktree']);
		}

		// Single pages pages ?
		if(!empty($PageReq))
		{
			// load the "Main" template
			loadTemplate($context['PMx_templatedir'] .'PortaMx');
			$context['page_title'] = $context['forum_name'] .' - '. ucwords(str_replace('-', ' ', $PageReq));
			$action = 'pages';
		}

		// get all block on active panels they can view
		$context['PortaMx']['viewblocks'] = getPanelsToShow($action, !empty($PageReq));

		// setup headers
		PortaMx_headers($action);

		loadTemplate($context['PMx_templatedir'] .'Mainindex');
		$context['template_layers'][] = 'portamx';
	}
}
?>