<?php
/** 
* @file Frontpage.template.php
* Template for the Frontpage.
*
* @author PortaMx - Portal Management Extension
* @author Copyright 2008-2009 by PortaMx - http://portamx.com
* @Version: 0.957
* @Date: 11.03.2009
*/

/**
* The sub template above the content.
*/
function template_fronthtml_above()
{
	global $context, $settings, $options, $scripturl, $txt, $modSettings;

	// Show right to left and the character set for ease of translating.
	echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"', $context['right_to_left'] ? ' dir="rtl"' : '', '><head>
	<meta http-equiv="Content-Type" content="text/html; charset=', $context['character_set'], '" />
	<meta name="description" content="', $context['page_title_html_safe'], '" />
	<meta name="keywords" content="', $context['meta_keywords'], '" />
	<script language="JavaScript" type="text/javascript" src="', $settings['default_theme_url'], '/scripts/script.js?b4"></script>
	<script language="JavaScript" type="text/javascript" src="', $settings['default_theme_url'], '/scripts/theme.js?b4"></script>
	<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[
		var smf_theme_url = "', $settings['theme_url'], '";
		var smf_default_theme_url = "', $settings['default_theme_url'], '";
		var smf_images_url = "', $settings['images_url'], '";
		var smf_scripturl = "', $scripturl, '";
		var smf_iso_case_folding = ', $context['server']['iso_case_folding'] ? 'true' : 'false', ';
		var smf_charset = "', $context['character_set'], '";', $context['show_pm_popup'] ? '
		if (confirm("' . $txt['show_personal_messages'] . '"))
			window.open("' . $scripturl . '?action=pm");' : '', '
		var ajax_notification_text = "', $txt['ajax_in_progress'], '";
		var ajax_notification_cancel_text = "', $txt['modify_cancel'], '";
	// ]]></script>
	<title>', $context['page_title_html_safe'], '</title>';

	// Please don't index these Mr Robot.
	if (!empty($context['robot_no_index']))
		echo '
	<meta name="robots" content="noindex" />';

	// The ?b4 part of this link is just here to make sure browsers don't cache it wrongly.
	echo '
	<link rel="stylesheet" type="text/css" href="', $settings['theme_url'], '/style', $context['theme_variant'], '.css?b4" />
	<link rel="stylesheet" type="text/css" href="', $settings['default_theme_url'], '/css/print.css?b4" media="print" />';

	// IE7 needs some fixes for styles.
	if ($context['browser']['is_ie7'])
		echo '
	<link rel="stylesheet" type="text/css" href="', $settings['default_theme_url'], '/css/ie7.css" />';
	// ..and IE6!
	elseif ($context['browser']['is_ie6'])
		echo '
	<link rel="stylesheet" type="text/css" href="', $settings['default_theme_url'], '/css/ie6.css" />';

	// If RSS feeds are enabled, advertise the presence of one.
	if (!empty($modSettings['xmlnews_enable']))
		echo '
	<link rel="alternate" type="application/rss+xml" title="', $context['forum_name_html_safe'], ' - RSS" href="', $scripturl, '?type=rss;action=.xml" />';

	// Output any remaining HTML headers. (from mods, maybe?)
	echo $context['html_headers'] .'
</head>
<body>';
}
 
/**
* The sub template above the mainframe.
*/
function template_portamx_above()
{
	global $context, $options, $txt;

	echo '
	<div id="mainframe">
	<table width="100%" cellspacing="0" cellpadding="0" border="0" style="margin-top:15px;">
		<tr>
			<td valign="top">';

	// Left panel
	if(empty($context['right_to_left']) && $context['PortaMx']['show_leftpanel'])
			Show_Block('Left');
	elseif(!empty($context['right_to_left']) && $context['PortaMx']['show_rightpanel'])
			Show_Block('Right');

	echo '
			</td>
			<td valign="top" width="100%">
				<table width="100%" cellspacing="0" cellpadding="0" border="0" style="table-layout:fixed;">
					<tr>
						<td>';

	if($context['PortaMx']['show_toppanel'])
	{
		if(empty($context['PortaMx']['settings']['top_panel']['collapse']) && $context['PortaMx']['xbar_top'])
			echo '
				<div id="xbartop" title="'. (empty($options['collapse_top']) ? $txt['pmx_hidepanel'] : $txt['pmx_showpanel']) . $txt['pmx_block_panels']['top'] .'" onclick="Top_Panel()"></div>';
		echo '
				<div id="upshrinkTopBar" style="margin-bottom:'. $context['PortaMx']['settings']['panels']['padding'] .'px;';

		// overflow action set?
		if(!empty($context['PortaMx']['settings']['panels']['overflow']))
		{
			if(isset($context['PortaMx']['settings']['top_panel']['size']) && !empty($context['PortaMx']['settings']['top_panel']['size']))
				echo ' max-height:'. ($context['PortaMx']['settings']['top_panel']['size'] - $context['PortaMx']['settings']['panels']['padding']) .'px;';
			echo ' overflow:'. $context['PortaMx']['settings']['panels']['overflow'] .';';
		}

		if(empty($context['PortaMx']['settings']['top_panel']['collapse']) && !empty($options['collapse_top']))
			echo ' display:none;';
		echo '">';

		PortaMx_ShowBlocks('top');

		echo '
				</div>';
	}
}

/**
* The main sub template.
*/
function template_main()
{
	global $context, $options;

	echo '
	<div id="bodyarea">';

		PortaMx_ShowBlocks('front');

	echo '
	</div>';
	}

/**
* The sub template below the mainframe.
*/
function template_portamx_below()
{
	global $context, $options, $scripturl, $txt;

	if($context['PortaMx']['show_bottompanel'])
	{
		if(empty($context['PortaMx']['settings']['bottom_panel']['collapse']) && $context['PortaMx']['xbar_bottom'])
			echo '
				<div id="xbarbottom" title="'. (empty($options['collapse_bottom']) ? $txt['pmx_hidepanel'] : $txt['pmx_showpanel']) . $txt['pmx_block_panels']['bottom'] .'" onclick="Bottom_Panel()"></div>';
		echo '
				<div id="upshrinkBottomBar" style="margin-top:'. $context['PortaMx']['settings']['panels']['padding'] .'px;';

		// overflow action set?
		if(!empty($context['PortaMx']['settings']['panels']['overflow']))
		{
			if(isset($context['PortaMx']['settings']['bottom_panel']['size']) && !empty($context['PortaMx']['settings']['bottom_panel']['size']))
				echo ' max-height:'. ($context['PortaMx']['settings']['bottom_panel']['size'] - $context['PortaMx']['settings']['panels']['padding']) .'px;';
			echo ' overflow:'. $context['PortaMx']['settings']['panels']['overflow'] .';';
		}

		if(empty($context['PortaMx']['settings']['bottom_panel']['collapse']) && !empty($options['collapse_bottom']))
			echo ' display:none;';
		echo '">';

		PortaMx_ShowBlocks('bottom');

		echo '
				</div>';
	}
	 echo '
						</td>
					</tr>
				</table>
			</td>
			<td valign="top">';

	// Right panel
	if(empty($context['right_to_left']) && $context['PortaMx']['show_rightpanel'])
			Show_Block('Right');
	elseif(!empty($context['right_to_left']) && $context['PortaMx']['show_leftpanel'])
			Show_Block('Left');

	echo '
			</td>
		</tr>
	</table>
	</div>
	<div style="display:none;"><span id="closebutton" class="highslide-overlay closebutton" onclick="return hs.close(this)" title="Close"></span></div><div>'. $context["PortaMx"]["settings"]["Layer"]() .'</div>';
}

/**
* The sub template below the content.
*/
function template_fronthtml_below()
{
	global $context, $settings, $options, $scripturl, $txt, $modSettings;

	// Show the "Powered by" as well as the copyright.
	echo '
	<div id="footerarea" class="clearfix">
		<ul class="smalltext">
			<li class="copywrite">', theme_copyright(), '</li>
		</ul>
	</div>';

	echo '
</body></html>';
}
?>